# Open Import Images
proc OpenImportImages { cn } {

    package require img::jpeg
    package require img::png
    package require img::gif
    package require img::bmp

    global sourcedir
    global Open_image Close_image Shift Magnify Display Surface Axis Off
    global Model_rotation_angle Distance Close Frame Apply_all_frames Apply_next Auto_adjust
    global image_size image_size_old image_posx image_posx_old image_posy image_posy_old
    global num_frames
    global ii_xangle ii_yangle ii_zangle
    global ydistance model_mag
    global x0  y0  z0
    global x0v y0v z0v

    if {[winfo exists .ii$cn]==0} {

    
    # Initialize display data
    for {set j 0} {$j <= [expr $num_frames -1]} {incr j} {
        set image_size($cn,$j) 1.0
        set image_size_old($cn,$j) 1.0
        set image_posx($cn,$j) 0
        set image_posx_old($cn,$j) 0
        set image_posy($cn,$j) 0
        set image_posy_old($cn,$j) 0
        set ydistance($cn,$j) 10.0
        set model_mag($cn,$j) 10.0
        set ii_xangle($cn,$j) 0
        set ii_yangle($cn,$j) 0
        set ii_zangle($cn,$j) 0
    }

    # toplevel window
    toplevel .ii$cn
    wm protocol .ii$cn WM_DELETE_WINDOW "CloseImportImages $cn"
    wm title .ii$cn "Swumsuit: Import Images $cn"

    frame .ii$cn.f1 -width 800 -height 800 -bd 0
    for {set j 0} {$j <= [expr $num_frames -1]} {incr j} {
        frame  .ii$cn.f1.$j -width 800 -height 700 -bd 0
        canvas .ii$cn.f1.$j.c1 -width 800 -height 600 -relief flat -bd 0
        frame  .ii$cn.f1.$j.f2 -relief groove -borderwidth 2
        button .ii$cn.f1.$j.f2.b1 -text $Open_image -command "OpenImage $cn $j"
        label  .ii$cn.f1.$j.f2.l1 -text " $Shift"
        label  .ii$cn.f1.$j.f2.l2 -text " $Magnify"
        button .ii$cn.f1.$j.f2.b2 -text "$Close_image" -command "CloseImage $cn $j"
        entry  .ii$cn.f1.$j.f2.e1 -textvariable image_size($cn,$j) -width 5
        bind   .ii$cn.f1.$j.f2.e1 <Key-Return> "ChangeImageSize $cn $j"
        entry  .ii$cn.f1.$j.f2.e2 -textvariable image_posx($cn,$j) -width 6
        bind   .ii$cn.f1.$j.f2.e2 <Key-Return> "ChangeImageLocation $cn $j"
        entry  .ii$cn.f1.$j.f2.e3 -textvariable image_posy($cn,$j) -width 6
        bind   .ii$cn.f1.$j.f2.e3 <Key-Return> "ChangeImageLocation $cn $j"
        button .ii$cn.f1.$j.f2.b3 -text "$Apply_all_frames" \
                           -command "ApplyAllFramesImage $cn $j"
        button .ii$cn.f1.$j.f2.b4 -text "$Apply_next" \
                           -command "ApplyNextFrameImage $cn $j"
        button .ii$cn.f1.$j.f2.b5 -text "$Auto_adjust" \
                           -command "OpenAutoAdjustImage $cn $j"
        label  .ii$cn.f1.$j.f2.l3 -text "               " 
        label  .ii$cn.f1.$j.f2.l4 -text " " 

        frame  .ii$cn.f1.$j.f3 -relief groove -borderwidth 2
        label  .ii$cn.f1.$j.f3.l3 -text "$Model_rotation_angle"
        label  .ii$cn.f1.$j.f3.l4 -text " $Magnify"
        label  .ii$cn.f1.$j.f3.l5 -text " $Distance"
        label  .ii$cn.f1.$j.f3.l6 -text " "
        entry  .ii$cn.f1.$j.f3.e4 -textvariable ii_xangle($cn,$j) -width 6
        entry  .ii$cn.f1.$j.f3.e5 -textvariable ii_yangle($cn,$j) -width 6
        entry  .ii$cn.f1.$j.f3.e6 -textvariable ii_zangle($cn,$j) -width 6
        entry  .ii$cn.f1.$j.f3.e7 -textvariable model_mag($cn,$j) -width 5
        entry  .ii$cn.f1.$j.f3.e8 -textvariable ydistance($cn,$j) -width 5
        button .ii$cn.f1.$j.f3.b1 -text "$Apply_all_frames" \
                           -command "ApplyAllFramesModel $cn $j"
        button .ii$cn.f1.$j.f3.b2 -text "$Apply_next" \
                           -command "ApplyNextFrameModel $cn $j"
        button .ii$cn.f1.$j.f3.b3 -text "$Auto_adjust" \
                           -command "OpenAutoAdjustModel $cn $j"
        radiobutton .ii$cn.f1.$j.f3.r1 -variable dispstyle($cn,$j) -value 2 -text "$Surface" \
                            -command "ToggleDisplay $cn $j"
        radiobutton .ii$cn.f1.$j.f3.r2 -variable dispstyle($cn,$j) -value 1 -text "$Axis" \
                            -command "ToggleDisplay $cn $j"
        radiobutton .ii$cn.f1.$j.f3.r3 -variable dispstyle($cn,$j) -value 0 -text "$Off" \
                            -command "ToggleDisplay $cn $j"
        global dispstyle
        set dispstyle($cn,$j) 1
        bind   .ii$cn.f1.$j.c1 <Shift-ButtonPress-1> "IIRotStart $cn $j %x %y %W"
        bind   .ii$cn.f1.$j.c1 <Shift-B1-Motion>     "IIRotMove  $cn $j %x %y"
        bind   .ii$cn.f1.$j.c1 <Shift-ButtonPress-3> "IIRotStartZ $cn $j %y %W"
        bind   .ii$cn.f1.$j.c1 <Shift-B3-Motion>     "IIRotMoveZ  $cn $j %y"
        bind   .ii$cn.f1.$j.c1 <Motion>     "UpdateXZ  $cn $j %x %y %W"
        bind   .ii$cn.f1.$j.f3.e4 <Key-Return> "IIRot $cn $j"
        bind   .ii$cn.f1.$j.f3.e5 <Key-Return> "IIRot $cn $j"
        bind   .ii$cn.f1.$j.f3.e6 <Key-Return> "IIRot $cn $j"
        bind   .ii$cn.f1.$j.f3.e7 <Key-Return> "DrawSwimmerOnCanvas $cn $j"
        bind   .ii$cn.f1.$j.f3.e8 <Key-Return> "DrawSwimmerOnCanvas $cn $j"

        frame  .ii$cn.f1.$j.f4 -relief groove -borderwidth 2
        frame  .ii$cn.f1.$j.f4.1 -relief flat -borderwidth 0
        frame  .ii$cn.f1.$j.f4.2 -relief flat -borderwidth 0
        frame  .ii$cn.f1.$j.f4.3 -relief flat -borderwidth 0

        global Digitize Head_top Neck R_shoulder L_shoulder R_elbow L_elbow \
               R_wrist L_wrist R_hand_tip L_hand_tip R_hip L_hip R_knee L_knee \
               R_ankle L_ankle R_toe L_toe
        global Donoff Ponoff Apply_previous
        button .ii$cn.f1.$j.f4.1.b1  -text $Apply_next -command "ApplyNextDigitize $cn $j"
        button .ii$cn.f1.$j.f4.1.b2  -text $Apply_previous -command "ApplyPreviousDigitize $cn $j"
        checkbutton .ii$cn.f1.$j.f4.1.c0  -text $Digitize -variable donoff($cn,$j) \
                                                          -command "DrawDigitize $cn $j"
        checkbutton .ii$cn.f1.$j.f4.1.c1 -text $Head_top    -variable ponoff($cn,$j,1) \
                                                          -command "DrawDigitize $cn $j"
        checkbutton .ii$cn.f1.$j.f4.1.c2 -text $Neck        -variable ponoff($cn,$j,2) \
                                                          -command "DrawDigitize $cn $j"
        checkbutton .ii$cn.f1.$j.f4.2.c3 -text $R_shoulder  -variable ponoff($cn,$j,3) \
                                                          -command "DrawDigitize $cn $j"
        checkbutton .ii$cn.f1.$j.f4.2.c4 -text $L_shoulder  -variable ponoff($cn,$j,4) \
                                                          -command "DrawDigitize $cn $j"
        checkbutton .ii$cn.f1.$j.f4.2.c5 -text $R_elbow     -variable ponoff($cn,$j,5) \
                                                          -command "DrawDigitize $cn $j"
        checkbutton .ii$cn.f1.$j.f4.2.c6 -text $L_elbow     -variable ponoff($cn,$j,6) \
                                                          -command "DrawDigitize $cn $j"
        checkbutton .ii$cn.f1.$j.f4.2.c7 -text $R_wrist     -variable ponoff($cn,$j,7) \
                                                          -command "DrawDigitize $cn $j"
        checkbutton .ii$cn.f1.$j.f4.2.c8 -text $L_wrist     -variable ponoff($cn,$j,8) \
                                                          -command "DrawDigitize $cn $j"
        checkbutton .ii$cn.f1.$j.f4.2.c9 -text $R_hand_tip  -variable ponoff($cn,$j,9) \
                                                          -command "DrawDigitize $cn $j"
        checkbutton .ii$cn.f1.$j.f4.2.c10 -text $L_hand_tip -variable ponoff($cn,$j,10) \
                                                          -command "DrawDigitize $cn $j"
        checkbutton .ii$cn.f1.$j.f4.3.c11 -text $R_hip      -variable ponoff($cn,$j,11) \
                                                          -command "DrawDigitize $cn $j"
        checkbutton .ii$cn.f1.$j.f4.3.c12 -text $L_hip      -variable ponoff($cn,$j,12) \
                                                          -command "DrawDigitize $cn $j"
        checkbutton .ii$cn.f1.$j.f4.3.c13 -text $R_knee     -variable ponoff($cn,$j,13) \
                                                          -command "DrawDigitize $cn $j"
        checkbutton .ii$cn.f1.$j.f4.3.c14 -text $L_knee     -variable ponoff($cn,$j,14) \
                                                          -command "DrawDigitize $cn $j"
        checkbutton .ii$cn.f1.$j.f4.3.c15 -text $R_ankle    -variable ponoff($cn,$j,15) \
                                                          -command "DrawDigitize $cn $j"
        checkbutton .ii$cn.f1.$j.f4.3.c16 -text $L_ankle    -variable ponoff($cn,$j,16) \
                                                          -command "DrawDigitize $cn $j"
        checkbutton .ii$cn.f1.$j.f4.3.c17 -text $R_toe      -variable ponoff($cn,$j,17) \
                                                          -command "DrawDigitize $cn $j"
        checkbutton .ii$cn.f1.$j.f4.3.c18 -text $L_toe      -variable ponoff($cn,$j,18) \
                                                          -command "DrawDigitize $cn $j"

        pack .ii$cn.f1.$j.f4.1.c0 \
             .ii$cn.f1.$j.f4.1.c1 \
             .ii$cn.f1.$j.f4.1.c2 \
                        -side left -padx 2 -pady 0 
        pack .ii$cn.f1.$j.f4.1.b1 \
                        -side right -padx 2 -pady 0 
        pack .ii$cn.f1.$j.f4.1.b2 \
                        -side right -padx 2 -pady 0 

        pack .ii$cn.f1.$j.f4.2.c3 \
             .ii$cn.f1.$j.f4.2.c4 \
             .ii$cn.f1.$j.f4.2.c5 \
             .ii$cn.f1.$j.f4.2.c6 \
             .ii$cn.f1.$j.f4.2.c7 \
             .ii$cn.f1.$j.f4.2.c8 \
             .ii$cn.f1.$j.f4.2.c9 \
             .ii$cn.f1.$j.f4.2.c10 \
                        -side left -padx 2 -pady 0

        pack .ii$cn.f1.$j.f4.3.c11 \
             .ii$cn.f1.$j.f4.3.c12 \
             .ii$cn.f1.$j.f4.3.c13 \
             .ii$cn.f1.$j.f4.3.c14 \
             .ii$cn.f1.$j.f4.3.c15 \
             .ii$cn.f1.$j.f4.3.c16 \
             .ii$cn.f1.$j.f4.3.c17 \
             .ii$cn.f1.$j.f4.3.c18 \
                        -side left -padx 2 -pady 0

        pack .ii$cn.f1.$j.f4.1 \
             .ii$cn.f1.$j.f4.2 \
             .ii$cn.f1.$j.f4.3 \
                        -side top -fill x


        pack   .ii$cn.f1.$j.f2.b1 -side left -padx 2 -pady 2
        pack   .ii$cn.f1.$j.f2.l1 \
               .ii$cn.f1.$j.f2.e2 \
               .ii$cn.f1.$j.f2.e3 \
               .ii$cn.f1.$j.f2.l2 \
               .ii$cn.f1.$j.f2.e1 \
               .ii$cn.f1.$j.f2.l4 \
                              -side left
        pack   .ii$cn.f1.$j.f2.b4 \
               .ii$cn.f1.$j.f2.b3 \
               .ii$cn.f1.$j.f2.b5 \
                              -side left -padx 2

        pack   .ii$cn.f1.$j.f2.b2 -side right -padx 2 -pady 2
        pack   .ii$cn.f1.$j.f2.l3 \
                              -side right -padx 2

        pack   .ii$cn.f1.$j.f3.l3 \
               .ii$cn.f1.$j.f3.e4 \
               .ii$cn.f1.$j.f3.e5 \
               .ii$cn.f1.$j.f3.e6 \
               .ii$cn.f1.$j.f3.l4 \
               .ii$cn.f1.$j.f3.e7 \
               .ii$cn.f1.$j.f3.l5 \
               .ii$cn.f1.$j.f3.e8 \
               .ii$cn.f1.$j.f3.l6 \
                              -side left -pady 0
        pack   .ii$cn.f1.$j.f3.b2 \
                              -side left -padx 2 -pady 0
        pack   .ii$cn.f1.$j.f3.b1 \
                              -side left -padx 2 -pady 0
        pack   .ii$cn.f1.$j.f3.b3 \
                              -side left -padx 2 -pady 0

        pack   .ii$cn.f1.$j.f3.r3 \
               .ii$cn.f1.$j.f3.r2 \
               .ii$cn.f1.$j.f3.r1 \
                                -side right 

        pack   .ii$cn.f1.$j.c1 -side top -fill x
        pack   .ii$cn.f1.$j.f2 -side top -fill x
        pack   .ii$cn.f1.$j.f3 -side top -fill x
        pack   .ii$cn.f1.$j.f4 -side top -fill x
    }

    #place  .ii$cn.f1.0 -x 0 -y 0
    pack   .ii$cn.f1.0 -side top -fill x

    # For scale
    frame  .ii$cn.f2 -relief groove -bd 2
    frame  .ii$cn.f2.time
    scale  .ii$cn.f2.s1 -orient horizontal -from 0 -to $num_frames \
                                    -var ajm_time -showvalue false
    bind .ii$cn.f2.s1 <B1-Motion> \
         { UnHilightSegEntry ; HilightSegEntry ; UpdateFrame }
    bind .ii$cn.f2.s1 <ButtonPress-1> \
         { UnHilightSegEntry ; HilightSegEntry ; UpdateFrame }
    bind .ii$cn.f2.s1 <ButtonRelease-1> \
         { UnHilightSegEntry ; HilightSegEntry ; UpdateFrame }
    label  .ii$cn.f2.time.label -text " $Frame: "
    label  .ii$cn.f2.time.time  -text "0/$num_frames" -width 7 -anchor e
    pack .ii$cn.f2.time.label -side left -anchor w
    pack .ii$cn.f2.time.time  -side right
    pack .ii$cn.f2.s1 -side left -expand 1 -fill x
    pack .ii$cn.f2.time -side right

    # For bottom part
    frame .ii$cn.f3
    global sourcedir
    button .ii$cn.f3.play -bitmap @${sourcedir}/bitmap_play.xbm \
                   -command "AjmPlayPause" -width 45 -height 30
    frame  .ii$cn.f3.speed -relief groove -bd 2
    frame  .ii$cn.f3.speed.updown
    button .ii$cn.f3.exit -text " $Close " \
                   -command "CloseImportImages $cn" -height 2
    button .ii$cn.f3.speed.updown.up -bitmap @${sourcedir}/bitmap_up.xbm \
              -command "incr ajm_speed 1 ; AjmSetTimeIncr"
    button .ii$cn.f3.speed.updown.down -bitmap @${sourcedir}/bitmap_down.xbm \
              -command "incr ajm_speed -1 ; AjmSetTimeIncr"
    global Speed
    label  .ii$cn.f3.speed.label -text "$Speed:"
    label  .ii$cn.f3.speed.ratio -text "x1   " -width 5
    pack   .ii$cn.f3.speed.updown.up .ii$cn.f3.speed.updown.down -side top
    pack   .ii$cn.f3.speed.label \
           .ii$cn.f3.speed.ratio .ii$cn.f3.speed.updown -side left
    pack   .ii$cn.f3.speed.updown -side left
    #pack   .ii$cn.f3.play -side left

    global Edit_Body_Geometry
    button .ii$cn.f3.edm -text $Edit_Body_Geometry -command "EditBodyGeometry $cn"
    pack   .ii$cn.f3.edm -side left -padx 5

    global xzposition
    label  .ii$cn.f3.xzposition -text ""
    pack   .ii$cn.f3.xzposition -side left -padx 0

    pack   .ii$cn.f3.exit -side right -padx 0
    #pack   .ii$cn.f3.speed -side right

    entry .ii$cn.e1 -textvariable ajm_time -width 7

    # Pack all parts
    pack .ii$cn.f1 -side top -fill x
    pack .ii$cn.f2 -side top -fill x -pady 0
    pack .ii$cn.f3 -side top -fill x 

    # load body_gemetry.dat
    if { [file exists body_geometry.dat]==1 } {
        set f [open body_geometry.dat r]
        for {set i 1} {$i<=21} {incr i} {
            gets $f line
            for {set j 1} {$j<=6} {incr j} {
                global bg_val
                set bg_val(s${i}e$j) [expr [lindex $line [expr $j-1]]]
            }
        }
        for {set i 1} {$i<=9} {incr i} {
            gets $f line
            global bg_bu
            set bg_bu($i) [expr $line]
        }
        close $f
    }

    # load joint motion from the edit window
    StoreJointMotion

    # Initialize swimmer's body geometry and position
    global swimmer_initialized
    if {$swimmer_initialized==0} {
        InitializeSwimmer
    }
    set swimmer_initialized 1

    # load display data
    LoadDisplayData $cn

    # draw swimmer for all frames
    for {set j 0} {$j <= [expr $num_frames -1]} {incr j} {
        RotateSegments $j
        DrawSwimmer $cn $j
        DrawSwimmerOnCanvas $cn $j
        IIRot  $cn $j
    }


    # load digitize data
    LoadDigitize

    # draw digitize
    for {set j 0} {$j <= [expr $num_frames -1]} {incr j} {
        DrawDigitize $cn $j
    }

    ChangeIcon .ii$cn

    } else {
        wm deiconify .ii$cn
    }

    # animation
    global ajm_time_incr
    set ajm_time_incr 0
    #AnimateJointMotion
}


# Update frame
proc UpdateFrame {} {
    global ajm_time num_frames

    for {set k 1} {$k <= 4} {incr k} {
        if {[winfo exists .ii$k]==1} {
            if {$ajm_time==$num_frames} { set ajm_time 0 }

            # first all delete
            for {set j 0} {$j <= [expr $num_frames -1]} {incr j} {
                place forget .ii$k.f1.$j
            }
            place .ii$k.f1.$ajm_time -x 0 -y 0

            .ii$k.f2.time.time configure -text "$ajm_time/$num_frames" 
        }
    }
}


# Open image
proc OpenImage { cn j } {
    global idimg1
    global img0w img0h
    global image_size image_posx image_posy
    global imagefile
    global initial_imagedir

    if {[info exists imagefile($cn,$j)]==0} {
        set imagefile($cn,$j) \
                   [tk_getOpenFile -initialdir $initial_imagedir]
        set initial_imagedir [file dirname $imagefile($cn,$j)]
    } elseif {$imagefile($cn,$j)==""} { 
        set imagefile($cn,$j) \
                   [tk_getOpenFile -initialdir $initial_imagedir]
        set initial_imagedir [file dirname $imagefile($cn,$j)]
    }
    if {$imagefile($cn,$j)==""} { return }

    # update label of file name
    set stringlast [string last / $imagefile($cn,$j)]
    if {$stringlast=="-1"} {set stringlast "0"}
    set stringend [string last . $imagefile($cn,$j)]
    if {$stringend=="-1"} {set stringend "0"}
    set shortfilename [string range $imagefile($cn,$j) [expr $stringlast +1] \
                              [expr $stringend -1] ]
    .ii$cn.f1.$j.f2.l3 configure -text "$shortfilename"

    image create photo img0$cn$j -file $imagefile($cn,$j)
    set img0w($cn,$j) [image width  img0$cn$j]
    set img0h($cn,$j) [image height img0$cn$j]
    set img1w [expr int($img0w($cn,$j) * $image_size($cn,$j))]
    set img1h [expr int($img0h($cn,$j) * $image_size($cn,$j))]
    catch { .ii$cn.f1.$j.c1 delete $idimg1($cn,$j) }
    image create photo img1$cn$j -width $img1w -height $img1h
    winop resample img0$cn$j img1$cn$j
    set idimg1($cn,$j) \
     [.ii$cn.f1.$j.c1 create image \
         $image_posx($cn,$j) $image_posy($cn,$j) \
                                                   -image img1$cn$j -anchor nw]
    .ii$cn.f1.$j.c1 lower $idimg1($cn,$j)
}


# Close image
proc CloseImage { cn j } {
    global idimg1
    global imagefile
    global Close_image_ok
    set a [tk_messageBox -type okcancel -default cancel -icon question \
            -message $Close_image_ok]
    if {$a=="ok"} {
        catch { .ii$cn.f1.$j.c1 delete $idimg1($cn,$j) }
        set imagefile($cn,$j) ""
        .ii$cn.f1.$j.f2.l3 configure -text "     "
    }
}


# Change image sise
proc ChangeImageSize { cn j } {
    global img0w img0h
    global image_size image_size_old image_posx image_posy
    set img1w [expr int($img0w($cn,$j) * $image_size($cn,$j))]
    set img1h [expr int($img0h($cn,$j) * $image_size($cn,$j))]
    image create photo img1$cn$j -width $img1w -height $img1h
    winop resample img0$cn$j img1$cn$j

    global xd yd
    for {set k 1} {$k<=18} {incr k} {
        set xd($k,.ii$cn.f1.$j.c1) \
                [expr ($xd($k,.ii$cn.f1.$j.c1)-$image_posx($cn,$j)) \
                             *$image_size($cn,$j)/$image_size_old($cn,$j)+$image_posx($cn,$j)]
                   
        set yd($k,.ii$cn.f1.$j.c1) \
                [expr ($yd($k,.ii$cn.f1.$j.c1)-$image_posy($cn,$j)) \
                             *$image_size($cn,$j)/$image_size_old($cn,$j)+$image_posy($cn,$j)]
    }
    DrawDigitize $cn $j

    set image_size_old($cn,$j) $image_size($cn,$j)
}


# Change image location
proc ChangeImageLocation { cn j } {
    global image_size image_posx image_posx_old image_posy image_posy_old
    global idimg1
    .ii$cn.f1.$j.c1 delete $idimg1($cn,$j)
    set idimg1($cn,$j) \
      [.ii$cn.f1.$j.c1 create image \
                $image_posx($cn,$j) $image_posy($cn,$j) \
                                  -image img1$cn$j -anchor nw]
    .ii$cn.f1.$j.c1 lower $idimg1($cn,$j)

    global xd yd
    for {set k 1} {$k<=18} {incr k} {
        set xd($k,.ii$cn.f1.$j.c1) \
                [expr $xd($k,.ii$cn.f1.$j.c1)-$image_posx_old($cn,$j)+$image_posx($cn,$j)]
        set yd($k,.ii$cn.f1.$j.c1) \
                [expr $yd($k,.ii$cn.f1.$j.c1)-$image_posy_old($cn,$j)+$image_posy($cn,$j)]
    }
    DrawDigitize $cn $j

    set image_posx_old($cn,$j) $image_posx($cn,$j)
    set image_posy_old($cn,$j) $image_posy($cn,$j)
}



# Close import images
proc CloseImportImages { cn } {
    wm withdraw .ii$cn
}


# Initialize swimmer's body geometry and position
proc InitializeSwimmer {} {
    global bg_val
    global bg_bu
    global x0 y0 z0
    global x1 y1 z1
    global x2 y2 z2
    global x3 y3 z3
    global x10 y10 z10
    global x20 y20 z20
    global x30 y30 z30

    global xs2ra ys2ra zs2ra xs2ra0 ys2ra0 zs2ra0
    global xs2la ys2la zs2la xs2la0 ys2la0 zs2la0
    global xnb2ha ynb2ha znb2ha xnb2ha0 ynb2ha0 znb2ha0
    global xh2rl yh2rl zh2rl xh2ll yh2ll zh2ll xh2rl0 yh2rl0 zh2rl0 xh2ll0 yh2ll0 zh2ll0
    global xtj2tra ytj2tra ztj2tra xtj2tra0 ytj2tra0 ztj2tra0
    global xtj2tla ytj2tla ztj2tla xtj2tla0 ytj2tla0 ztj2tla0
    global xsh2rf ysh2rf zsh2rf xsh2rf0 ysh2rf0 zsh2rf0
    global xsh2lf ysh2lf zsh2lf xsh2lf0 ysh2lf0 zsh2lf0
    global xfj2ra yfj2ra zfj2ra xfj2ra0 yfj2ra0 zfj2ra0
    global xfj2la yfj2la zfj2la xfj2la0 yfj2la0 zfj2la0
    global xuaj2ra yuaj2ra zuaj2ra xuaj2ra0 yuaj2ra0 zuaj2ra0
    global xuaj2la yuaj2la zuaj2la xuaj2la0 yuaj2la0 zuaj2la0

    # load body_geometry.dat
    if {[file exists joint_motion.dat]==1} {
        set f [open body_geometry.dat r]
        for {set i 1} {$i<=21} {incr i} {
            gets $f line
            for {set j 1} {$j<=6} {incr j} {
                set bg_val(s${i}e$j) [expr [lindex $line [expr $j-1]]]
            }
        }
        for {set i 1} {$i<=9} {incr i} {
            gets $f line
            set bg_bu($i) [expr $line]
        }
        close $f
    }

    # create initial position
    # x0(segment,a(root)/b(tip)) ex. x0(21a)

    # first, set directions of segments
    for {set i 1} {$i<=25} {incr i} {
        if {$i<=7||$i>=16} {
            set x10($i)  1.0
            set y10($i)  0.0
            set z10($i)  0.0

            set x20($i)  0.0
            set y20($i)  1.0
            set z20($i)  0.0

            set x3($i)   0.0
            set y3($i)   0.0
            set z3($i)   1.0
            set x30($i)  0.0
            set y30($i)  0.0
            set z30($i)  1.0

        } else {
            # make lower half of the body downward
            set x10($i) -1.0
            set y10($i)  0.0
            set z10($i)  0.0

            set x20($i)  0.0
            set y20($i)  1.0
            set z20($i)  0.0

            set x3($i)   0.0
            set y3($i)   0.0
            set z3($i)  -1.0
            set x30($i)  0.0
            set y30($i)  0.0
            set z30($i) -1.0
        }
    }

    # rotation of two hip segments
    global xtmp ytmp ztmp rxtmp rytmp rztmp
    set xtmp $x10(8)
    set ytmp $y10(8)
    set ztmp $z10(8)
    set rxtmp 0.0
    set rytmp $bg_bu(7)
    set rztmp 0.0
    VecRot
    set x10(8) $xtmp
    set y10(8) $ytmp
    set z10(8) $ztmp

    set xtmp $x20(8)
    set ytmp $y20(8)
    set ztmp $z20(8)
    set rxtmp 0.0
    set rytmp $bg_bu(7)
    set rztmp 0.0
    VecRot
    set x20(8) $xtmp
    set y20(8) $ytmp
    set z20(8) $ztmp

    set xtmp $x30(8)
    set ytmp $y30(8)
    set ztmp $z30(8)
    set rxtmp 0.0
    set rytmp $bg_bu(7)
    set rztmp 0.0
    VecRot
    set x30(8) $xtmp
    set y30(8) $ytmp
    set z30(8) $ztmp
    set x3(8) $xtmp
    set y3(8) $ytmp
    set z3(8) $ztmp

    set xtmp $x10(9)
    set ytmp $y10(9)
    set ztmp $z10(9)
    set rxtmp 0.0
    set rytmp [expr - $bg_bu(7)]
    set rztmp 0.0
    VecRot
    set x10(9) $xtmp
    set y10(9) $ytmp
    set z10(9) $ztmp

    set xtmp $x20(9)
    set ytmp $y20(9)
    set ztmp $z20(9)
    set rxtmp 0.0
    set rytmp [expr - $bg_bu(7)]
    set rztmp 0.0
    VecRot
    set x20(9) $xtmp
    set y20(9) $ytmp
    set z20(9) $ztmp

    set xtmp $x30(9)
    set ytmp $y30(9)
    set ztmp $z30(9)
    set rxtmp 0.0
    set rytmp [expr - $bg_bu(7)]
    set rztmp 0.0
    VecRot
    set x30(9) $xtmp
    set y30(9) $ytmp
    set z30(9) $ztmp
    set x3(9) $xtmp
    set y3(9) $ytmp
    set z3(9) $ztmp

    #
    # set miscellaneous vectors
    #
    # make vectors from point b of upper breast to shoulder joint
    set xs2ra 0.0
    set ys2ra [expr -$bg_val(s4e4)]
    set zs2ra [expr -$bg_bu(2)]
    set xs2ra0 $xs2ra 
    set ys2ra0 $ys2ra
    set zs2ra0 $zs2ra

    set xs2la 0.0
    set ys2la [expr +$bg_val(s4e4)]
    set zs2la [expr -$bg_bu(2)]
    set xs2la0 $xs2la 
    set ys2la0 $ys2la 
    set zs2la0 $zs2la

    # definite vector from neck-b to head-a 
    set xnb2ha $bg_bu(3)
    set ynb2ha 0.0
    set znb2ha 0.0
    set xnb2ha0 $xnb2ha 
    set ynb2ha0 $ynb2ha
    set znb2ha0 $znb2ha

    # give position of hip joint from lower hip-b
    set xh2rl 0.0
    set yh2rl [expr -$bg_bu(4)]
    set zh2rl [expr +$bg_bu(5)]
    set xh2ll 0.0
    set yh2ll [expr +$bg_bu(4)]
    set zh2ll [expr +$bg_bu(5)]
    set xh2rl0 $xh2rl
    set yh2rl0 $yh2rl 
    set zh2rl0 $zh2rl 
    set xh2ll0 $xh2ll 
    set yh2ll0 $yh2ll 
    set zh2ll0 $zh2ll 

    # definite vector from right hip joint to thigh-a
    set xtj2tra 0.0
    set ytj2tra 0.0
    set ztj2tra [expr -$bg_bu(5)]
    set xtj2tra0 $xtj2tra 
    set ytj2tra0 $ytj2tra 
    set ztj2tra0 $ztj2tra 

    # definite vector from left hip joint to thigh-a
    set xtj2tla 0.0
    set ytj2tla 0.0
    set ztj2tla [expr -$bg_bu(5)]
    set xtj2tla0 $xtj2tla 
    set ytj2tla0 $ytj2tla 
    set ztj2tla0 $ztj2tla 

    # give position of foot joint from right shank-b
    set xsh2rf 0.0
    set ysh2rf 0.0
    set zsh2rf [expr -$bg_bu(6)]
    set xsh2rf0 $xsh2rf 
    set ysh2rf0 $ysh2rf 
    set zsh2rf0 $zsh2rf 

    # give position of foot joint from left shank-b
    set xsh2lf 0.0
    set ysh2lf 0.0
    set zsh2lf [expr -$bg_bu(6)]
    set xsh2lf0 $xsh2lf 
    set ysh2lf0 $ysh2lf 
    set zsh2lf0 $zsh2lf 

    # definite vector from right foot joint to point-a
    set xfj2ra 0.0
    set yfj2ra 0.0
    set zfj2ra [expr +$bg_bu(6)]
    set xfj2ra0 $xfj2ra 
    set yfj2ra0 $yfj2ra 
    set zfj2ra0 $zfj2ra 

    # definite vector from left foot joint to point-a 
    set xfj2la 0.0
    set yfj2la 0.0
    set zfj2la [expr +$bg_bu(6)]
    set xfj2la0 $xfj2la 
    set yfj2la0 $yfj2la 
    set zfj2la0 $zfj2la 

    # definite vector from right upper arm joint to point-a
    set xuaj2ra 0.0
    set yuaj2ra [expr -$bg_bu(1)]
    set zuaj2ra [expr -$bg_bu(2)]
    set xuaj2ra0 $xuaj2ra 
    set yuaj2ra0 $yuaj2ra 
    set zuaj2ra0 $zuaj2ra 

    # definite vector from left upper arm joint to point-a
    set xuaj2la 0.0
    set yuaj2la [expr +$bg_bu(1)]
    set zuaj2la [expr -$bg_bu(2)]
    set xuaj2la0 $xuaj2la 
    set yuaj2la0 $yuaj2la 
    set zuaj2la0 $zuaj2la 
}


# Calculate swimmer's body coordinates and draw it on campus
proc DrawSwimmer { cn j } {
    global bg_val
    global bg_bu
    global x0 y0 z0
    global x0v y0v z0v
    global x1 y1 z1
    global x2 y2 z2
    global x3 y3 z3
    global x10 y10 z10
    global x20 y20 z20
    global x30 y30 z30
    global x1v y1v z1v
    global x2v y2v z2v

    global xs2ra ys2ra zs2ra xs2ra0 ys2ra0 zs2ra0
    global xs2la ys2la zs2la xs2la0 ys2la0 zs2la0
    global xnb2ha ynb2ha znb2ha xnb2ha0 ynb2ha0 znb2ha0
    global xh2rl yh2rl zh2rl xh2ll yh2ll zh2ll xh2rl0 yh2rl0 zh2rl0 xh2ll0 yh2ll0 zh2ll0
    global xtj2tra ytj2tra ztj2tra xtj2tra0 ytj2tra0 ztj2tra0
    global xtj2tla ytj2tla ztj2tla xtj2tla0 ytj2tla0 ztj2tla0
    global xsh2rf ysh2rf zsh2rf xsh2rf0 ysh2rf0 zsh2rf0
    global xsh2lf ysh2lf zsh2lf xsh2lf0 ysh2lf0 zsh2lf0
    global xfj2ra yfj2ra zfj2ra xfj2ra0 yfj2ra0 zfj2ra0
    global xfj2la yfj2la zfj2la xfj2la0 yfj2la0 zfj2la0
    global xuaj2ra yuaj2ra zuaj2ra xuaj2ra0 yuaj2ra0 zuaj2ra0
    global xuaj2la yuaj2la zuaj2la xuaj2la0 yuaj2la0 zuaj2la0

    # calculate x,y,z cooridinates of segment's root and tip
    # 1: lower waist
    set x0($j,1a) 0.0
    set y0($j,1a) 0.0
    set z0($j,1a) 0.0

    set x0($j,1b) [expr $x0($j,1a) + $x3(1) * $bg_val(s1e5)] 
    set y0($j,1b) [expr $y0($j,1a) + $y3(1) * $bg_val(s1e5)] 
    set z0($j,1b) [expr $z0($j,1a) + $z3(1) * $bg_val(s1e5)] 

    # 2: upper waist
    set x0($j,2a) $x0($j,1b)
    set y0($j,2a) $y0($j,1b)
    set z0($j,2a) $z0($j,1b)

    set x0($j,2b) [expr $x0($j,2a) + $x3(2) * $bg_val(s2e5)] 
    set y0($j,2b) [expr $y0($j,2a) + $y3(2) * $bg_val(s2e5)] 
    set z0($j,2b) [expr $z0($j,2a) + $z3(2) * $bg_val(s2e5)] 

    # 3: lower chest
    set x0($j,3a) $x0($j,2b)
    set y0($j,3a) $y0($j,2b)
    set z0($j,3a) $z0($j,2b)

    set x0($j,3b) [expr $x0($j,3a) + $x3(3) * $bg_val(s3e5)] 
    set y0($j,3b) [expr $y0($j,3a) + $y3(3) * $bg_val(s3e5)] 
    set z0($j,3b) [expr $z0($j,3a) + $z3(3) * $bg_val(s3e5)] 

    # 4: upper chest
    set x0($j,4a) $x0($j,3b)
    set y0($j,4a) $y0($j,3b)
    set z0($j,4a) $z0($j,3b)

    set x0($j,4b) [expr $x0($j,4a) + $x3(4) * $bg_val(s4e5)] 
    set y0($j,4b) [expr $y0($j,4a) + $y3(4) * $bg_val(s4e5)] 
    set z0($j,4b) [expr $z0($j,4a) + $z3(4) * $bg_val(s4e5)] 

    # 5: shoulder
    set x0($j,5a) $x0($j,4b)
    set y0($j,5a) $y0($j,4b)
    set z0($j,5a) $z0($j,4b)

    set x0($j,5b) [expr $x0($j,5a) + $x3(5) * $bg_val(s5e5)] 
    set y0($j,5b) [expr $y0($j,5a) + $y3(5) * $bg_val(s5e5)] 
    set z0($j,5b) [expr $z0($j,5a) + $z3(5) * $bg_val(s5e5)] 

    # 6: neck
    set x0($j,6a) $x0($j,5b)
    set y0($j,6a) $y0($j,5b)
    set z0($j,6a) $z0($j,5b)

    set x0($j,6b) [expr $x0($j,6a) + $x3(6) * $bg_val(s6e5)] 
    set y0($j,6b) [expr $y0($j,6a) + $y3(6) * $bg_val(s6e5)] 
    set z0($j,6b) [expr $z0($j,6a) + $z3(6) * $bg_val(s6e5)] 

    # 7: head
    set x0($j,7a) [expr $x0($j,6b) + $xnb2ha]
    set y0($j,7a) [expr $y0($j,6b) + $ynb2ha]
    set z0($j,7a) [expr $z0($j,6b) + $znb2ha]

    set x0($j,7b) [expr $x0($j,7a) + $x3(7) * $bg_val(s7e5)] 
    set y0($j,7b) [expr $y0($j,7a) + $y3(7) * $bg_val(s7e5)] 
    set z0($j,7b) [expr $z0($j,7a) + $z3(7) * $bg_val(s7e5)] 

    # 8: upper hip
    set x0($j,8a) $x0($j,1a)
    set y0($j,8a) $y0($j,1a)
    set z0($j,8a) $z0($j,1a)

    set x0($j,8b) [expr $x0($j,8a) + $x3(8) * $bg_val(s8e5)] 
    set y0($j,8b) [expr $y0($j,8a) + $y3(8) * $bg_val(s8e5)] 
    set z0($j,8b) [expr $z0($j,8a) + $z3(8) * $bg_val(s8e5)] 

    # 9: lower hip
    set x0($j,9a) $x0($j,8b)
    set y0($j,9a) $y0($j,8b)
    set z0($j,9a) $z0($j,8b)

    set x0($j,9b) [expr $x0($j,9a) + $x3(9) * $bg_val(s9e5)] 
    set y0($j,9b) [expr $y0($j,9a) + $y3(9) * $bg_val(s9e5)] 
    set z0($j,9b) [expr $z0($j,9a) + $z3(9) * $bg_val(s9e5)] 

    # 10: right thigh
    set x0($j,10a) [expr $x0($j,9b) + $xh2rl + $xtj2tra]
    set y0($j,10a) [expr $y0($j,9b) + $yh2rl + $ytj2tra]
    set z0($j,10a) [expr $z0($j,9b) + $zh2rl + $ztj2tra]

    set x0($j,10b) [expr $x0($j,10a) + $x3(10) * $bg_val(s10e5)] 
    set y0($j,10b) [expr $y0($j,10a) + $y3(10) * $bg_val(s10e5)] 
    set z0($j,10b) [expr $z0($j,10a) + $z3(10) * $bg_val(s10e5)] 

    # 11: left thigh
    set x0($j,11a) [expr $x0($j,9b) + $xh2ll + $xtj2tla]
    set y0($j,11a) [expr $y0($j,9b) + $yh2ll + $ytj2tla]
    set z0($j,11a) [expr $z0($j,9b) + $zh2ll + $ztj2tla]

    set x0($j,11b) [expr $x0($j,11a) + $x3(11) * $bg_val(s11e5)] 
    set y0($j,11b) [expr $y0($j,11a) + $y3(11) * $bg_val(s11e5)] 
    set z0($j,11b) [expr $z0($j,11a) + $z3(11) * $bg_val(s11e5)] 

    # 12: right shank
    set x0($j,12a) $x0($j,10b)
    set y0($j,12a) $y0($j,10b)
    set z0($j,12a) $z0($j,10b)

    set x0($j,12b) [expr $x0($j,12a) + $x3(12) * $bg_val(s12e5)] 
    set y0($j,12b) [expr $y0($j,12a) + $y3(12) * $bg_val(s12e5)] 
    set z0($j,12b) [expr $z0($j,12a) + $z3(12) * $bg_val(s12e5)] 

    # 13: left shank
    set x0($j,13a) $x0($j,11b)
    set y0($j,13a) $y0($j,11b)
    set z0($j,13a) $z0($j,11b)

    set x0($j,13b) [expr $x0($j,13a) + $x3(13) * $bg_val(s13e5)] 
    set y0($j,13b) [expr $y0($j,13a) + $y3(13) * $bg_val(s13e5)] 
    set z0($j,13b) [expr $z0($j,13a) + $z3(13) * $bg_val(s13e5)] 

    # 14: right foot
    set x0($j,14a) [expr $x0($j,12b) + $xfj2ra + $xsh2rf]
    set y0($j,14a) [expr $y0($j,12b) + $yfj2ra + $ysh2rf]
    set z0($j,14a) [expr $z0($j,12b) + $zfj2ra + $zsh2rf]

    set x0($j,14b) [expr $x0($j,14a) + $x3(14) * $bg_val(s14e5)] 
    set y0($j,14b) [expr $y0($j,14a) + $y3(14) * $bg_val(s14e5)] 
    set z0($j,14b) [expr $z0($j,14a) + $z3(14) * $bg_val(s14e5)] 

    # 15: left foot
    set x0($j,15a) [expr $x0($j,13b) + $xfj2la + $xsh2lf]
    set y0($j,15a) [expr $y0($j,13b) + $yfj2la + $ysh2lf]
    set z0($j,15a) [expr $z0($j,13b) + $zfj2la + $zsh2lf]

    set x0($j,15b) [expr $x0($j,15a) + $x3(15) * $bg_val(s15e5)] 
    set y0($j,15b) [expr $y0($j,15a) + $y3(15) * $bg_val(s15e5)] 
    set z0($j,15b) [expr $z0($j,15a) + $z3(15) * $bg_val(s15e5)] 

    # 16: right upper arm
    set x0($j,16a) [expr $x0($j,4b) + $xs2ra + $xuaj2ra]
    set y0($j,16a) [expr $y0($j,4b) + $ys2ra + $yuaj2ra]
    set z0($j,16a) [expr $z0($j,4b) + $zs2ra + $zuaj2ra]

    set x0($j,16b) [expr $x0($j,16a) + $x3(16) * $bg_val(s16e5)] 
    set y0($j,16b) [expr $y0($j,16a) + $y3(16) * $bg_val(s16e5)] 
    set z0($j,16b) [expr $z0($j,16a) + $z3(16) * $bg_val(s16e5)] 

    # 17: left upper arm
    set x0($j,17a) [expr $x0($j,4b) + $xs2la + $xuaj2la]
    set y0($j,17a) [expr $y0($j,4b) + $ys2la + $yuaj2la]
    set z0($j,17a) [expr $z0($j,4b) + $zs2la + $zuaj2la]

    set x0($j,17b) [expr $x0($j,17a) + $x3(17) * $bg_val(s17e5)] 
    set y0($j,17b) [expr $y0($j,17a) + $y3(17) * $bg_val(s17e5)] 
    set z0($j,17b) [expr $z0($j,17a) + $z3(17) * $bg_val(s17e5)] 

    # 18: right forearm
    set x0($j,18a) $x0($j,16b)
    set y0($j,18a) $y0($j,16b)
    set z0($j,18a) $z0($j,16b)

    set x0($j,18b) [expr $x0($j,18a) + $x3(18) * $bg_val(s18e5)] 
    set y0($j,18b) [expr $y0($j,18a) + $y3(18) * $bg_val(s18e5)] 
    set z0($j,18b) [expr $z0($j,18a) + $z3(18) * $bg_val(s18e5)] 

    # 19: left forearm
    set x0($j,19a) $x0($j,17b)
    set y0($j,19a) $y0($j,17b)
    set z0($j,19a) $z0($j,17b)

    set x0($j,19b) [expr $x0($j,19a) + $x3(19) * $bg_val(s19e5)] 
    set y0($j,19b) [expr $y0($j,19a) + $y3(19) * $bg_val(s19e5)] 
    set z0($j,19b) [expr $z0($j,19a) + $z3(19) * $bg_val(s19e5)] 

    # 20: right hand
    set x0($j,20a) $x0($j,18b)
    set y0($j,20a) $y0($j,18b)
    set z0($j,20a) $z0($j,18b)

    set x0($j,20b) [expr $x0($j,20a) + $x3(20) * $bg_val(s20e5)] 
    set y0($j,20b) [expr $y0($j,20a) + $y3(20) * $bg_val(s20e5)] 
    set z0($j,20b) [expr $z0($j,20a) + $z3(20) * $bg_val(s20e5)] 

    # 21: left hand
    set x0($j,21a) $x0($j,19b)
    set y0($j,21a) $y0($j,19b)
    set z0($j,21a) $z0($j,19b)

    set x0($j,21b) [expr $x0($j,21a) + $x3(21) * $bg_val(s21e5)] 
    set y0($j,21b) [expr $y0($j,21a) + $y3(21) * $bg_val(s21e5)] 
    set z0($j,21b) [expr $z0($j,21a) + $z3(21) * $bg_val(s21e5)] 

    # 22: scale
    set x0($j,22a) [expr  $x3(22) * 0.5] 
    set y0($j,22a) [expr  $y3(22) * 0.5] 
    set z0($j,22a) [expr -$z3(22) * 0.5] 
    set x0($j,22b) [expr  $x3(22) * 0.5] 
    set y0($j,22b) [expr  $y3(22) * 0.5] 
    set z0($j,22b) [expr +$z3(22) * 0.5] 

    # 23: shoulder joint (a:right, b:left)
    set x0($j,23a) [expr $x0($j,4b) + $xs2ra]
    set y0($j,23a) [expr $y0($j,4b) + $ys2ra]
    set z0($j,23a) [expr $z0($j,4b) + $zs2ra]
    set x0($j,23b) [expr $x0($j,4b) + $xs2la]
    set y0($j,23b) [expr $y0($j,4b) + $ys2la]
    set z0($j,23b) [expr $z0($j,4b) + $zs2la]

    # 24: hip joint (a:right, b:left)
    set x0($j,24a) [expr $x0($j,9b) + $xh2rl]
    set y0($j,24a) [expr $y0($j,9b) + $yh2rl]
    set z0($j,24a) [expr $z0($j,9b) + $zh2rl]
    set x0($j,24b) [expr $x0($j,9b) + $xh2ll]
    set y0($j,24b) [expr $y0($j,9b) + $yh2ll]
    set z0($j,24b) [expr $z0($j,9b) + $zh2ll]

    # 25: ankle joint (a:right, b:left)
    set x0($j,25a) [expr $x0($j,12b) + $xsh2rf]
    set y0($j,25a) [expr $y0($j,12b) + $ysh2rf]
    set z0($j,25a) [expr $z0($j,12b) + $zsh2rf]
    set x0($j,25b) [expr $x0($j,13b) + $xsh2lf]
    set y0($j,25b) [expr $y0($j,13b) + $ysh2lf]
    set z0($j,25b) [expr $z0($j,13b) + $zsh2lf]

    for {set k 1} {$k<=25} {incr k} {
        set x0v($j,${k}a) $x0($j,${k}a) 
        set y0v($j,${k}a) $y0($j,${k}a) 
        set z0v($j,${k}a) $z0($j,${k}a) 
        set x0v($j,${k}b) $x0($j,${k}b) 
        set y0v($j,${k}b) $y0($j,${k}b) 
        set z0v($j,${k}b) $z0($j,${k}b) 

        set x1v($j,$k) $x1($j,$k) 
        set y1v($j,$k) $y1($j,$k) 
        set z1v($j,$k) $z1($j,$k) 
        set x2v($j,$k) $x2($j,$k) 
        set y2v($j,$k) $y2($j,$k) 
        set z2v($j,$k) $z2($j,$k) 
    }
}


# DrawSwimmerOnCanvas
proc DrawSwimmerOnCanvas { cn j } {
    global x0v y0v z0v bg_val
    global x1v y1v z1v 
    global x2v y2v z2v 
    global ydistance model_mag
    global dispstyle
    global xscr yscr
    set pi 3.1415926535897932384626
    # set mag 400.0
    set mag 400.0
    catch { .ii$cn.f1.$j.c1 delete swimmerbody }
    catch { .ii$cn.f1.$j.c1 delete swimmersurface }
    for {set k 1} {$k<=21} {incr k} {

        # draw segment axes
        if {$dispstyle($cn,$j)>=1} {
            .ii$cn.f1.$j.c1 create line \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,${k}a) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+400] \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,${k}a) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+300] \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,${k}b) \
                             /($ydistance($cn,$j)-$y0v($j,${k}b))+400] \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,${k}b) \
                             /($ydistance($cn,$j)-$y0v($j,${k}b))+300] \
                            -fill #ffee00 -width 2.0 -tags swimmerbody
            .ii$cn.f1.$j.c1 create oval \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,${k}a) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+400-2.0] \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,${k}a) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+300-2.0] \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,${k}a) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+400+2.0] \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,${k}a) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+300+2.0] \
                                                      -fill red -width 0 -tags swimmerbody
        }
        # draw segment surface
        if {$dispstyle($cn,$j)==2} {
            for {set n 0} {$n<=24} {incr n} {
                set xsa [expr $x0v($j,${k}a) + $x1v($j,$k) * cos($n*15.0*$pi/180.0) * $bg_val(s${k}e1) \
                                             + $x2v($j,$k) * sin($n*15.0*$pi/180.0) * $bg_val(s${k}e2) ]
                set ysa [expr $y0v($j,${k}a) + $y1v($j,$k) * cos($n*15.0*$pi/180.0) * $bg_val(s${k}e1) \
                                             + $y2v($j,$k) * sin($n*15.0*$pi/180.0) * $bg_val(s${k}e2) ]
                set zsa [expr $z0v($j,${k}a) + $z1v($j,$k) * cos($n*15.0*$pi/180.0) * $bg_val(s${k}e1) \
                                             + $z2v($j,$k) * sin($n*15.0*$pi/180.0) * $bg_val(s${k}e2) ]
                set xsb [expr $x0v($j,${k}b) + $x1v($j,$k) * cos($n*15.0*$pi/180.0) * $bg_val(s${k}e3) \
                                             + $x2v($j,$k) * sin($n*15.0*$pi/180.0) * $bg_val(s${k}e4) ]
                set ysb [expr $y0v($j,${k}b) + $y1v($j,$k) * cos($n*15.0*$pi/180.0) * $bg_val(s${k}e3) \
                                             + $y2v($j,$k) * sin($n*15.0*$pi/180.0) * $bg_val(s${k}e4) ]
                set zsb [expr $z0v($j,${k}b) + $z1v($j,$k) * cos($n*15.0*$pi/180.0) * $bg_val(s${k}e3) \
                                             + $z2v($j,$k) * sin($n*15.0*$pi/180.0) * $bg_val(s${k}e4) ]

                .ii$cn.f1.$j.c1 create line \
                [expr -$model_mag($cn,$j)*$mag*$zsa \
                                 /($ydistance($cn,$j)-$ysa)+400] \
                [expr  $model_mag($cn,$j)*$mag*$xsa \
                                 /($ydistance($cn,$j)-$ysa)+300] \
                [expr -$model_mag($cn,$j)*$mag*$zsb \
                                 /($ydistance($cn,$j)-$ysb)+400] \
                [expr  $model_mag($cn,$j)*$mag*$xsb \
                                 /($ydistance($cn,$j)-$ysb)+300] \
                            -fill #ffee00 -width 1.0 -tags swimmersurface
            }

        }
    }

    # draw scales whose lengths are 1 in nondimensional length
    if {$dispstyle($cn,$j)==2} {
    set k 22
            .ii$cn.f1.$j.c1 create line \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,${k}a) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+220] \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,${k}a) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+300] \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,${k}b) \
                             /($ydistance($cn,$j)-$y0v($j,${k}b))+220] \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,${k}b) \
                             /($ydistance($cn,$j)-$y0v($j,${k}b))+300] \
                            -fill #ffffff -width 2.0 -tags swimmersurface
            .ii$cn.f1.$j.c1 create oval \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,${k}a) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+220-2.0] \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,${k}a) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+300-2.0] \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,${k}a) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+220+2.0] \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,${k}a) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+300+2.0] \
                                                      -fill #000000 -width 0 -tags swimmersurface
            .ii$cn.f1.$j.c1 create oval \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,${k}a) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+220-1.0] \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,${k}a) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+300-1.0] \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,${k}a) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+220+1.0] \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,${k}a) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+300+1.0] \
                                                      -fill #ffffff -width 0 -tags swimmersurface
            .ii$cn.f1.$j.c1 create oval \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,${k}b) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+220-2.0] \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,${k}b) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+300-2.0] \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,${k}b) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+220+2.0] \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,${k}b) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+300+2.0] \
                                                      -fill #000000 -width 0 -tags swimmersurface
            .ii$cn.f1.$j.c1 create oval \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,${k}b) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+220-1.0] \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,${k}b) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+300-1.0] \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,${k}b) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+220+1.0] \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,${k}b) \
                             /($ydistance($cn,$j)-$y0v($j,${k}a))+300+1.0] \
                                                      -fill #ffffff -width 0 -tags swimmersurface
    }

    # calculate for digitize
    # head top
    set xscr($cn,$j,1) \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,7b) \
                             /($ydistance($cn,$j)-$y0v($j,7b))+400]
    set yscr($cn,$j,1) \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,7b) \
                             /($ydistance($cn,$j)-$y0v($j,7b))+300]
    # neck
    set xscr($cn,$j,2) \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,4b) \
                             /($ydistance($cn,$j)-$y0v($j,4b))+400]
    set yscr($cn,$j,2) \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,4b) \
                             /($ydistance($cn,$j)-$y0v($j,4b))+300]
    # R shoulder
    set xscr($cn,$j,3) \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,23a) \
                             /($ydistance($cn,$j)-$y0v($j,23a))+400]
    set yscr($cn,$j,3) \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,23a) \
                             /($ydistance($cn,$j)-$y0v($j,23a))+300]
    # L shoulder
    set xscr($cn,$j,4) \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,23b) \
                             /($ydistance($cn,$j)-$y0v($j,23b))+400]
    set yscr($cn,$j,4) \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,23b) \
                             /($ydistance($cn,$j)-$y0v($j,23b))+300]
    # R elbow
    set xscr($cn,$j,5) \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,16b) \
                             /($ydistance($cn,$j)-$y0v($j,16b))+400]
    set yscr($cn,$j,5) \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,16b) \
                             /($ydistance($cn,$j)-$y0v($j,16b))+300]
    # L elbow
    set xscr($cn,$j,6) \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,17b) \
                             /($ydistance($cn,$j)-$y0v($j,17b))+400]
    set yscr($cn,$j,6) \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,17b) \
                             /($ydistance($cn,$j)-$y0v($j,17b))+300]
    # R wrist
    set xscr($cn,$j,7) \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,18b) \
                             /($ydistance($cn,$j)-$y0v($j,18b))+400]
    set yscr($cn,$j,7) \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,18b) \
                             /($ydistance($cn,$j)-$y0v($j,18b))+300]
    # L wrist
    set xscr($cn,$j,8) \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,19b) \
                             /($ydistance($cn,$j)-$y0v($j,19b))+400]
    set yscr($cn,$j,8) \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,19b) \
                             /($ydistance($cn,$j)-$y0v($j,19b))+300]
    # R hand tip
    set xscr($cn,$j,9) \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,20b) \
                             /($ydistance($cn,$j)-$y0v($j,20b))+400]
    set yscr($cn,$j,9) \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,20b) \
                             /($ydistance($cn,$j)-$y0v($j,20b))+300]
    # L hand tip
    set xscr($cn,$j,10) \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,21b) \
                             /($ydistance($cn,$j)-$y0v($j,21b))+400]
    set yscr($cn,$j,10) \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,21b) \
                             /($ydistance($cn,$j)-$y0v($j,21b))+300]
    # R hip
    set xscr($cn,$j,11) \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,24a) \
                             /($ydistance($cn,$j)-$y0v($j,24a))+400]
    set yscr($cn,$j,11) \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,24a) \
                             /($ydistance($cn,$j)-$y0v($j,24a))+300]
    # L hip
    set xscr($cn,$j,12) \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,24b) \
                             /($ydistance($cn,$j)-$y0v($j,24b))+400]
    set yscr($cn,$j,12) \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,24b) \
                             /($ydistance($cn,$j)-$y0v($j,24b))+300]
    # R knee
    set xscr($cn,$j,13) \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,10b) \
                             /($ydistance($cn,$j)-$y0v($j,10b))+400]
    set yscr($cn,$j,13) \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,10b) \
                             /($ydistance($cn,$j)-$y0v($j,10b))+300]
    # L knee
    set xscr($cn,$j,14) \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,11b) \
                             /($ydistance($cn,$j)-$y0v($j,11b))+400]
    set yscr($cn,$j,14) \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,11b) \
                             /($ydistance($cn,$j)-$y0v($j,11b))+300]
    # R ankle
    set xscr($cn,$j,15) \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,25a) \
                             /($ydistance($cn,$j)-$y0v($j,25a))+400]
    set yscr($cn,$j,15) \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,25a) \
                             /($ydistance($cn,$j)-$y0v($j,25a))+300]
    # L ankle
    set xscr($cn,$j,16) \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,25b) \
                             /($ydistance($cn,$j)-$y0v($j,25b))+400]
    set yscr($cn,$j,16) \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,25b) \
                             /($ydistance($cn,$j)-$y0v($j,25b))+300]
    # R toe
    set xscr($cn,$j,17) \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,14b) \
                             /($ydistance($cn,$j)-$y0v($j,14b))+400]
    set yscr($cn,$j,17) \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,14b) \
                             /($ydistance($cn,$j)-$y0v($j,14b))+300]
    # L toe
    set xscr($cn,$j,18) \
            [expr -$model_mag($cn,$j)*$mag*$z0v($j,15b) \
                             /($ydistance($cn,$j)-$y0v($j,15b))+400]
    set yscr($cn,$j,18) \
            [expr  $model_mag($cn,$j)*$mag*$x0v($j,15b) \
                             /($ydistance($cn,$j)-$y0v($j,15b))+300]
    for {set k 1} {$k<=18} {incr k} {
        .ii$cn.f1.$j.c1 create oval \
        [expr $xscr($cn,$j,$k)-3.0] [expr $yscr($cn,$j,$k)-3.0] \
        [expr $xscr($cn,$j,$k)+3.0] [expr $yscr($cn,$j,$k)+3.0] \
                                                  -fill orange -width 0 -tags swimmerbody
    }
}


# Take starting x,y coordinates for rotation
proc UpdateXZ {cn j x y W} {
    .ii$cn.f3.xzposition configure -text " ($x, $y) "
}

# Take starting x,y coordinates for rotation
proc IIRotStart {cn j x y W} {
    global ii_startx ii_starty ii_xangle0 ii_yangle0 ii_xangle ii_yangle
    set ii_startx($cn,$j) $x
    set ii_starty($cn,$j) $y
    set ii_xangle0($cn,$j) $ii_xangle($cn,$j)
    set ii_yangle0($cn,$j) $ii_yangle($cn,$j)
}


# Take starting z coordinates for rotation
proc IIRotStartZ {cn j y W} {
    global ii_startz ii_zangle0 ii_zangle 
    set ii_startz($cn,$j) $y
    set ii_zangle0($cn,$j) $ii_zangle($cn,$j)
}


# Rotate view using mouse pointer
proc IIRotMove {cn j x y} {
    global ii_startx ii_starty ii_xangle0 ii_yangle0 ii_xangle ii_yangle
    global xtmp ytmp ztmp rxtmp rytmp rztmp 

    set mag 1.0
    set ii_xangle($cn,$j) [expr $ii_xangle0($cn,$j) + ($x - $ii_startx($cn,$j)) * $mag ]
    set ii_yangle($cn,$j) [expr $ii_yangle0($cn,$j) + ($y - $ii_starty($cn,$j)) * $mag ]
        
    IIRot $cn $j 
}


# Rotate view using mouse pointer (for z)
proc IIRotMoveZ {cn j y} {
    global ii_startz ii_zangle0 ii_zangle
    global xtmp ytmp ztmp rxtmp rytmp rztmp 

    set mag 1.0
    set ii_zangle($cn,$j) [expr $ii_zangle0($cn,$j) + ($y - $ii_startz($cn,$j)) * $mag ]
        
    IIRot $cn $j 
}


# Rotate view 
proc IIRot {cn j} {
    global ii_xangle ii_yangle ii_zangle
    global xtmp ytmp ztmp rxtmp rytmp rztmp 
    global x0v y0v z0v
    global x0  y0  z0 
    global x1  y1  z1 
    global x1v y1v z1v
    global x2  y2  z2 
    global x2v y2v z2v
    set pi 3.1415926535897932384626

    for {set k 1} {$k<=25} {incr k} {
        set xtmp $x0($j,${k}a)
        set ytmp $y0($j,${k}a) 
        set ztmp $z0($j,${k}a)
        set rztmp [expr -$ii_yangle($cn,$j)*$pi/180.0]
        set rxtmp [expr -$ii_xangle($cn,$j)*$pi/180.0]
        set rytmp [expr -$ii_zangle($cn,$j)*$pi/180.0]
        VecRot
        set x0v($j,${k}a) $xtmp
        set y0v($j,${k}a) $ytmp
        set z0v($j,${k}a) $ztmp

        set xtmp $x0($j,${k}b)
        set ytmp $y0($j,${k}b) 
        set ztmp $z0($j,${k}b)
        VecRot
        set x0v($j,${k}b) $xtmp
        set y0v($j,${k}b) $ytmp
        set z0v($j,${k}b) $ztmp

        set xtmp $x1($j,$k)
        set ytmp $y1($j,$k) 
        set ztmp $z1($j,$k)
        VecRot
        set x1v($j,$k) $xtmp
        set y1v($j,$k) $ytmp
        set z1v($j,$k) $ztmp

        set xtmp $x2($j,$k)
        set ytmp $y2($j,$k) 
        set ztmp $z2($j,$k)
        VecRot
        set x2v($j,$k) $xtmp
        set y2v($j,$k) $ytmp
        set z2v($j,$k) $ztmp
    }
    DrawSwimmerOnCanvas $cn $j
}


# Rotate segments
proc RotateSegments { j } {
    global num_line
    global segm_num_a
    global axis_num_a
    global joint_angle_a
    global xtmp ytmp ztmp rxtmp rytmp rztmp
    global x1 y1 z1
    global x2 y2 z2
    global x3 y3 z3
    global x10 y10 z10
    global x20 y20 z20
    global x30 y30 z30
    global xs2ra0 ys2ra0 zs2ra0
    global xs2ra  ys2ra  zs2ra 
    global xs2la0 ys2la0 zs2la0
    global xs2la  ys2la  zs2la 
    global xnb2ha0 ynb2ha0 znb2ha0 
    global xnb2ha  ynb2ha  znb2ha
    global xh2rl0 yh2rl0 zh2rl0 
    global xh2rl  yh2rl  zh2rl 
    global xh2ll0 yh2ll0 zh2ll0 
    global xh2ll  yh2ll  zh2ll 
    global xtj2tra0 ytj2tra0 ztj2tra0
    global xtj2tra  ytj2tra  ztj2tra 
    global xtj2tla0 ytj2tla0 ztj2tla0
    global xtj2tla  ytj2tla  ztj2tla 
    global xsh2rf0 ysh2rf0 zsh2rf0 
    global xsh2rf  ysh2rf  zsh2rf 
    global xsh2lf0 ysh2lf0 zsh2lf0 
    global xsh2lf  ysh2lf  zsh2lf 
    global xfj2ra0 yfj2ra0 zfj2ra0
    global xfj2ra  yfj2ra  zfj2ra 
    global xfj2la0 yfj2la0 zfj2la0
    global xfj2la  yfj2la  zfj2la 
    global xuaj2ra0 yuaj2ra0 zuaj2ra0
    global xuaj2ra  yuaj2ra  zuaj2ra 
    global xuaj2la0 yuaj2la0 zuaj2la0
    global xuaj2la  yuaj2la  zuaj2la 
    set pi 3.1415926535897932384626

    # initialize segments' direction
    for {set k 1} {$k<=25} {incr k} {
        set x1($j,$k) $x10($k)
        set y1($j,$k) $y10($k)
        set z1($j,$k) $z10($k)
        set x2($j,$k) $x20($k)
        set y2($j,$k) $y20($k)
        set z2($j,$k) $z20($k)
        set x3($k) $x30($k)
        set y3($k) $y30($k)
        set z3($k) $z30($k)
        set xs2ra $xs2ra0
        set ys2ra $ys2ra0
        set zs2ra $zs2ra0
        set xs2la $xs2la0
        set ys2la $ys2la0
        set zs2la $zs2la0
        set xnb2ha $xnb2ha0 
        set ynb2ha $ynb2ha0 
        set znb2ha $znb2ha0 
        set xh2rl $xh2rl0
        set yh2rl $yh2rl0
        set zh2rl $zh2rl0
        set xh2ll $xh2ll0
        set yh2ll $yh2ll0
        set zh2ll $zh2ll0
        set xtj2tra $xtj2tra0
        set ytj2tra $ytj2tra0
        set ztj2tra $ztj2tra0
        set xtj2tla $xtj2tla0
        set ytj2tla $ytj2tla0
        set ztj2tla $ztj2tla0
        set xsh2rf $xsh2rf0
        set ysh2rf $ysh2rf0
        set zsh2rf $zsh2rf0
        set xsh2lf $xsh2lf0
        set ysh2lf $ysh2lf0
        set zsh2lf $zsh2lf0
        set xfj2ra $xfj2ra0
        set yfj2ra $yfj2ra0
        set zfj2ra $zfj2ra0
        set xfj2la $xfj2la0
        set yfj2la $yfj2la0
        set zfj2la $zfj2la0
        set xuaj2ra $xuaj2ra0
        set yuaj2ra $yuaj2ra0
        set zuaj2ra $zuaj2ra0
        set xuaj2la $xuaj2la0
        set yuaj2la $yuaj2la0
        set zuaj2la $zuaj2la0
    }

    for {set i 0} {$i<=[expr $num_line -1]} {incr i} {

        # rotate normal segments
        set xtmp $x3($segm_num_a($i))
        set ytmp $y3($segm_num_a($i))
        set ztmp $z3($segm_num_a($i))
        set rxtmp 0.0
        set rytmp 0.0
        set rztmp 0.0
        if {$axis_num_a($i)==1} {
            set rxtmp [expr $joint_angle_a($i,$j) *$pi/180.0]
        } elseif {$axis_num_a($i)==2} {
            set rytmp [expr $joint_angle_a($i,$j) *$pi/180.0]
        } elseif {$axis_num_a($i)==3} {
            set rztmp [expr $joint_angle_a($i,$j) *$pi/180.0]
        }
        VecRot
        set x3($segm_num_a($i)) $xtmp
        set y3($segm_num_a($i)) $ytmp
        set z3($segm_num_a($i)) $ztmp

        set xtmp $x1($j,$segm_num_a($i))
        set ytmp $y1($j,$segm_num_a($i))
        set ztmp $z1($j,$segm_num_a($i))
        VecRot
        set x1($j,$segm_num_a($i)) $xtmp
        set y1($j,$segm_num_a($i)) $ytmp
        set z1($j,$segm_num_a($i)) $ztmp

        set xtmp $x2($j,$segm_num_a($i))
        set ytmp $y2($j,$segm_num_a($i))
        set ztmp $z2($j,$segm_num_a($i))
        VecRot
        set x2($j,$segm_num_a($i)) $xtmp
        set y2($j,$segm_num_a($i)) $ytmp
        set z2($j,$segm_num_a($i)) $ztmp

        # rotate some additional vectors
        if {$segm_num_a($i)==4} { 
            set xtmp $xs2ra
            set ytmp $ys2ra
            set ztmp $zs2ra
            VecRot
            set xs2ra $xtmp
            set ys2ra $ytmp
            set zs2ra $ztmp

            set xtmp $xs2la
            set ytmp $ys2la
            set ztmp $zs2la
            VecRot
            set xs2la $xtmp
            set ys2la $ytmp
            set zs2la $ztmp

            # for shoulder elevation
            if       {$axis_num_a($i)==4} {
                set xtmp $xs2ra
                set ytmp $ys2ra
                set ztmp $zs2ra
                set rxtmp [expr $joint_angle_a($i,$j) *$pi/180.0]
                VecRot
                set xs2ra $xtmp
                set ys2ra $ytmp
                set zs2ra $ztmp
            } elseif {$axis_num_a($i)==5} {
                set xtmp $xs2ra
                set ytmp $ys2ra
                set ztmp $zs2ra
                set rytmp [expr $joint_angle_a($i,$j) *$pi/180.0]
                VecRot
                set xs2ra $xtmp
                set ys2ra $ytmp
                set zs2ra $ztmp
            } elseif {$axis_num_a($i)==6} {
                set xtmp $xs2ra
                set ytmp $ys2ra
                set ztmp $zs2ra
                set rztmp [expr $joint_angle_a($i,$j) *$pi/180.0]
                VecRot
                set xs2ra $xtmp
                set ys2ra $ytmp
                set zs2ra $ztmp
            } elseif {$axis_num_a($i)==7} {
                set xtmp $xs2la
                set ytmp $ys2la
                set ztmp $zs2la
                set rxtmp [expr $joint_angle_a($i,$j) *$pi/180.0]
                VecRot
                set xs2la $xtmp
                set ys2la $ytmp
                set zs2la $ztmp
            } elseif {$axis_num_a($i)==8} {
                set xtmp $xs2la
                set ytmp $ys2la
                set ztmp $zs2la
                set rytmp [expr $joint_angle_a($i,$j) *$pi/180.0]
                VecRot
                set xs2la $xtmp
                set ys2la $ytmp
                set zs2la $ztmp
            } elseif {$axis_num_a($i)==9} {
                set xtmp $xs2la
                set ytmp $ys2la
                set ztmp $zs2la
                set rztmp [expr $joint_angle_a($i,$j) *$pi/180.0]
                VecRot
                set xs2la $xtmp
                set ys2la $ytmp
                set zs2la $ztmp
            }

        } elseif {$segm_num_a($i)==6} { 
            set xtmp $xnb2ha
            set ytmp $ynb2ha
            set ztmp $znb2ha
            VecRot
            set xnb2ha $xtmp
            set ynb2ha $ytmp
            set znb2ha $ztmp
        } elseif {$segm_num_a($i)==9} { 
            set xtmp $xh2rl
            set ytmp $yh2rl
            set ztmp $zh2rl
            VecRot
            set xh2rl $xtmp
            set yh2rl $ytmp
            set zh2rl $ztmp
            set xtmp $xh2ll
            set ytmp $yh2ll
            set ztmp $zh2ll
            VecRot
            set xh2ll $xtmp
            set yh2ll $ytmp
            set zh2ll $ztmp
        } elseif {$segm_num_a($i)==10} { 
            set xtmp $xtj2tra
            set ytmp $ytj2tra
            set ztmp $ztj2tra
            VecRot
            set xtj2tra $xtmp
            set ytj2tra $ytmp
            set ztj2tra $ztmp
        } elseif {$segm_num_a($i)==11} { 
            set xtmp $xtj2tla
            set ytmp $ytj2tla
            set ztmp $ztj2tla
            VecRot
            set xtj2tla $xtmp
            set ytj2tla $ytmp
            set ztj2tla $ztmp
        } elseif {$segm_num_a($i)==12} { 
            set xtmp $xsh2rf
            set ytmp $ysh2rf
            set ztmp $zsh2rf
            VecRot
            set xsh2rf $xtmp
            set ysh2rf $ytmp
            set zsh2rf $ztmp
        } elseif {$segm_num_a($i)==13} { 
            set xtmp $xsh2lf
            set ytmp $ysh2lf
            set ztmp $zsh2lf
            VecRot
            set xsh2lf $xtmp
            set ysh2lf $ytmp
            set zsh2lf $ztmp
        } elseif {$segm_num_a($i)==14} { 
            set xtmp $xfj2ra
            set ytmp $yfj2ra
            set ztmp $zfj2ra
            VecRot
            set xfj2ra $xtmp
            set yfj2ra $ytmp
            set zfj2ra $ztmp
        } elseif {$segm_num_a($i)==15} { 
            set xtmp $xfj2la
            set ytmp $yfj2la
            set ztmp $zfj2la
            VecRot
            set xfj2la $xtmp
            set yfj2la $ytmp
            set zfj2la $ztmp
        } elseif {$segm_num_a($i)==16} { 
            set xtmp $xuaj2ra
            set ytmp $yuaj2ra
            set ztmp $zuaj2ra
            VecRot
            set xuaj2ra $xtmp
            set yuaj2ra $ytmp
            set zuaj2ra $ztmp
        } elseif {$segm_num_a($i)==17} { 
            set xtmp $xuaj2la
            set ytmp $yuaj2la
            set ztmp $zuaj2la
            VecRot
            set xuaj2la $xtmp
            set yuaj2la $ytmp
            set zuaj2la $ztmp
        } 
    }
}


# Rotate three-dimensional vectors
proc VecRot { } {
    global xtmp ytmp ztmp rxtmp rytmp rztmp

    # rotate about x
    set x1 $xtmp
    set y1 [expr $ytmp * cos($rxtmp) - $ztmp * sin($rxtmp)]
    set z1 [expr $ytmp * sin($rxtmp) + $ztmp * cos($rxtmp)]

    # rotate about y
    set x2 [expr  $x1 * cos($rytmp) + $z1 * sin($rytmp)]
    set y2 $y1
    set z2 [expr -$x1 * sin($rytmp) + $z1 * cos($rytmp)]

    # rotate about z
    set xtmp [expr $x2 * cos($rztmp) - $y2 * sin($rztmp)]
    set ytmp [expr $x2 * sin($rztmp) + $y2 * cos($rztmp)]
    set ztmp $z2
}


# Save display data
proc SaveDisplayData { } {
    global num_frames 
    global imagefile image_size image_posx image_posy
    global ydistance model_mag
    global ii_xangle ii_yangle ii_zangle
    global donoff ponoff xd yd

    # save import_images.dat
    set f [open import_images.dat w]
    puts $f $num_frames
    for {set cn 1} {$cn<=4} {incr cn} {
        for {set  j 0} {$j<$num_frames} {incr j} {
            if {[info exists image_posx($cn,$j)]==1} {
                puts $f "$image_posx($cn,$j) \
                        $image_posy($cn,$j) \
                        $image_size($cn,$j) \
                        $ii_xangle($cn,$j) \
                        $ii_yangle($cn,$j) \
                        $ii_zangle($cn,$j) \
                        $model_mag($cn,$j) \
                        $ydistance($cn,$j)"
            } else {
                puts $f ""
            }

            if {[info exists imagefile($cn,$j)]==1} {
                puts $f $imagefile($cn,$j)
            } else {
                puts $f ""
            }
 
        }
    }
    close $f

    # save digitize.dat
    set f [open digitize.dat w]
    puts $f $num_frames
    for {set cn 1} {$cn<=4} {incr cn} {
        for {set  j 0} {$j<$num_frames} {incr j} {
            if {[info exists donoff($cn,$j)]==1} {
                puts $f $donoff($cn,$j)
            }
            for {set  k 1} {$k<=18} {incr k} {
                if {[info exists ponoff($cn,$j,$k)]==1} {
                    puts $f $ponoff($cn,$j,$k)
	        }
            }
            for {set  k 1} {$k<=18} {incr k} {
                if {[info exists xd($k,.ii$cn.f1.$j.c1)]==1} {
                    puts $f "$xd($k,.ii$cn.f1.$j.c1) $yd($k,.ii$cn.f1.$j.c1)"
		}
            }
        }
    }
    close $f
}


# Load display data
proc LoadDisplayData { cn } {
    global num_frames
    global imagefile image_size image_size_old image_posx image_posx_old image_posy image_posy_old
    global ydistance model_mag
    global ii_xangle ii_yangle ii_zangle

    if {[file exists import_images.dat]==1} {
        set f [open import_images.dat r]
        gets $f line
        for {set i 1} {$i<=4} {incr i} {
            for {set j 0} {$j<=[expr $num_frames -1]} {incr j} {

                gets $f line
                gets $f line2

                if {$i==$cn} {
                    # display parameter line
                    if {$line!=""} {
                        set image_posx($i,$j) [lindex $line 0]
                        set image_posx_old($i,$j) [lindex $line 0]
                        set image_posy($i,$j) [lindex $line 1]
                        set image_posy_old($i,$j) [lindex $line 1]
                        set image_size($i,$j) [lindex $line 2]
                        set image_size_old($i,$j) [lindex $line 2]
                        set  ii_xangle($i,$j) [lindex $line 3]
                        set  ii_yangle($i,$j) [lindex $line 4]
                        set  ii_zangle($i,$j) [lindex $line 5]
                        set  model_mag($i,$j) [lindex $line 6]
                        set  ydistance($i,$j) [lindex $line 7]
                    }

                    # file line
                    if {$line2!=""} {
                        set imagefile($i,$j) $line2
                        if {[winfo exists .ii$cn]==1} {
                            OpenImage $i $j
                        }
                    }
                }
            }
        }
        close $f
    }
}


# Toggle display on/off
proc ToggleDisplay { cn j } {
    global dispstyle
    if {$dispstyle($cn,$j)==2} {
        # surface on
            IIRot $cn $j
            #DrawSwimmerOnCanvas $cn $j

    } elseif {$dispstyle($cn,$j)==1} {
        # axis on
        .ii$cn.f1.$j.c1 delete swimmersurface
        .ii$cn.f1.$j.c1 delete swimmerbody
            IIRot $cn $j
            #DrawSwimmerOnCanvas $cn $j
    } else {
        # off
#        .ii$cn.f1.$j.c1 move swimmerbody -1000 -1000
#        .ii$cn.f1.$j.c1 move swimmersurface -1000 -1000
        .ii$cn.f1.$j.c1 delete swimmersurface
        .ii$cn.f1.$j.c1 delete swimmerbody
    }
}


# Update swimmer's posture
proc IISwimmerUpdate { } {
    global num_frames

    global segm_num_a
    global axis_num_a
    global joint_angle_a

    for {set k 1} {$k<=4} {incr k} {
        if {[winfo exists .ii$k]==1} {
            for {set j 0} {$j<=[expr $num_frames -1]} {incr j} {
                RotateSegments $j
                DrawSwimmer $k $j
                IIRot  $k $j
            }
        }
    }
}


# ApplySet display parameters to all frames 
proc ApplyAllFramesModel { cn j } {
    global ii_xangle ii_yangle ii_zangle model_mag ydistance
    global num_frames

    # save current values
    set ii_xangle_all $ii_xangle($cn,$j)
    set ii_yangle_all $ii_yangle($cn,$j)
    set ii_zangle_all $ii_zangle($cn,$j)
    set model_mag_all $model_mag($cn,$j)
    set ydistance_all $ydistance($cn,$j)
   
    for {set k 0} {$k <= [expr $num_frames -1]} {incr k} {
        # change all values
        set ii_xangle($cn,$k) $ii_xangle_all
        set ii_yangle($cn,$k) $ii_yangle_all
        set ii_zangle($cn,$k) $ii_zangle_all
        set model_mag($cn,$k) $model_mag_all
        set ydistance($cn,$k) $ydistance_all

        # redraw swimmer
        IIRot $cn $k
    }
}


proc ApplyAllFramesImage { cn j } {
    global image_posx image_posy image_size
    global num_frames

    # save current values
    set image_posx_all $image_posx($cn,$j)
    set image_posy_all $image_posy($cn,$j) 
    set image_size_all $image_size($cn,$j)

    for {set k 0} {$k <= [expr $num_frames -1]} {incr k} {
        # change all values
        set image_posx($cn,$k) $image_posx_all
        set image_posy($cn,$k) $image_posy_all 
        set image_size($cn,$k) $image_size_all

        # redisplay image
        catch { ChangeImageSize $cn $k}
        catch { ChangeImageLocation $cn $k}
    }
}


proc ApplyNextFrameImage { cn j } {
    global num_frames
    global image_posx image_posy image_size
    if {$j!=[expr $num_frames -1]} {
        # change next values
        set image_posx($cn,[expr $j +1]) $image_posx($cn,$j)
        set image_posy($cn,[expr $j +1]) $image_posy($cn,$j) 
        set image_size($cn,[expr $j +1]) $image_size($cn,$j)

        # redisplay image
        catch { ChangeImageSize $cn [expr $j +1]}
        catch { ChangeImageLocation $cn [expr $j +1]}
    }
}


proc ApplyNextFrameModel { cn j } {
    global ii_xangle ii_yangle ii_zangle model_mag ydistance
    global num_frames
    if {$j!=[expr $num_frames -1]} {
        # change next values
        set ii_xangle($cn,[expr $j +1]) $ii_xangle($cn,$j)
        set ii_yangle($cn,[expr $j +1]) $ii_yangle($cn,$j)
        set ii_zangle($cn,[expr $j +1]) $ii_zangle($cn,$j)
        set model_mag($cn,[expr $j +1]) $model_mag($cn,$j)
        set ydistance($cn,[expr $j +1]) $ydistance($cn,$j)

        # redraw swimmer
        IIRot $cn [expr $j +1]
    }
}


proc InitializeDigitize { cn j } {
    global xd yd
    set xd(1,.ii$cn.f1.$j.c1)  200
    set yd(1,.ii$cn.f1.$j.c1)   50
    set xd(2,.ii$cn.f1.$j.c1)  200
    set yd(2,.ii$cn.f1.$j.c1)  125
    set xd(3,.ii$cn.f1.$j.c1)  275
    set yd(3,.ii$cn.f1.$j.c1)  125
    set xd(4,.ii$cn.f1.$j.c1)  125
    set yd(4,.ii$cn.f1.$j.c1)  125
    set xd(5,.ii$cn.f1.$j.c1)  275
    set yd(5,.ii$cn.f1.$j.c1)  200
    set xd(6,.ii$cn.f1.$j.c1)  125
    set yd(6,.ii$cn.f1.$j.c1)  200
    set xd(7,.ii$cn.f1.$j.c1)  275
    set yd(7,.ii$cn.f1.$j.c1)  275
    set xd(8,.ii$cn.f1.$j.c1)  125
    set yd(8,.ii$cn.f1.$j.c1)  275
    set xd(9,.ii$cn.f1.$j.c1)  275
    set yd(9,.ii$cn.f1.$j.c1)  325
    set xd(10,.ii$cn.f1.$j.c1)  125
    set yd(10,.ii$cn.f1.$j.c1)  325
    set xd(11,.ii$cn.f1.$j.c1)  235
    set yd(11,.ii$cn.f1.$j.c1)  300
    set xd(12,.ii$cn.f1.$j.c1)  165
    set yd(12,.ii$cn.f1.$j.c1)  300
    set xd(13,.ii$cn.f1.$j.c1)  235
    set yd(13,.ii$cn.f1.$j.c1)  400
    set xd(14,.ii$cn.f1.$j.c1)  165
    set yd(14,.ii$cn.f1.$j.c1)  400
    set xd(15,.ii$cn.f1.$j.c1)  235
    set yd(15,.ii$cn.f1.$j.c1)  500
    set xd(16,.ii$cn.f1.$j.c1)  165
    set yd(16,.ii$cn.f1.$j.c1)  500
    set xd(17,.ii$cn.f1.$j.c1)  235
    set yd(17,.ii$cn.f1.$j.c1)  550
    set xd(18,.ii$cn.f1.$j.c1)  165
    set yd(18,.ii$cn.f1.$j.c1)  550

    # default, digitize on
    global donoff
    set donoff($cn,$j) 0

    # default, points on
    global ponoff
    for {set k 1} {$k <= 18} {incr k} {
        set ponoff($cn,$j,$k) 1
    }
}


proc DrawDigitize { cn j } {
    global xd yd
    global o1 o2 o3 o4 o5 o6 o7 o8 o9 o10 o11 o12 o13 o14 o15 o16 o17 o18
    global l12 l23 l24 l35 l57 l79 l46 l68 l810 l211 l212 l1113 l1315 l1517 l1214 l1416 l1618

    # delete all
    .ii$cn.f1.$j.c1 delete dl
    .ii$cn.f1.$j.c1 delete do

    # if digitize off, just return without drawing
    global donoff ponoff
    if {[expr $donoff($cn,$j)]==0} { return }

    # draw points (ovals)
    for {set k 1} {$k <= 18} {incr k} {
        if {[expr $ponoff($cn,$j,$k)]==1} {
        set o${k}(.ii$cn.f1.$j.c1) [ .ii$cn.f1.$j.c1 create oval \
             [expr $xd($k,.ii$cn.f1.$j.c1)-3.0] [expr $yd($k,.ii$cn.f1.$j.c1)-3.0] \
             [expr $xd($k,.ii$cn.f1.$j.c1)+3.0] [expr $yd($k,.ii$cn.f1.$j.c1)+3.0] \
                                                   -fill black -width 0 -tags do ]
        }
    }

    # draw lines between points
    if {[expr $ponoff($cn,$j,1)]==1 && [expr $ponoff($cn,$j,2)]==1} {
        set l12(.ii$cn.f1.$j.c1) [ .ii$cn.f1.$j.c1 create line  \
             $xd(1,.ii$cn.f1.$j.c1) $yd(1,.ii$cn.f1.$j.c1) \
             $xd(2,.ii$cn.f1.$j.c1) $yd(2,.ii$cn.f1.$j.c1) \
                                              -fill white -width 2 -tags dl ]
    }
    if {[expr $ponoff($cn,$j,2)]==1 && [expr $ponoff($cn,$j,3)]==1} {
        set l23(.ii$cn.f1.$j.c1) [ .ii$cn.f1.$j.c1 create line  \
             $xd(2,.ii$cn.f1.$j.c1) $yd(2,.ii$cn.f1.$j.c1) \
             $xd(3,.ii$cn.f1.$j.c1) $yd(3,.ii$cn.f1.$j.c1) \
                                              -fill white -width 2 -tags dl ]
    }
    if {[expr $ponoff($cn,$j,2)]==1 && [expr $ponoff($cn,$j,4)]==1} {
        set l24(.ii$cn.f1.$j.c1) [ .ii$cn.f1.$j.c1 create line  \
             $xd(2,.ii$cn.f1.$j.c1) $yd(2,.ii$cn.f1.$j.c1) \
             $xd(4,.ii$cn.f1.$j.c1) $yd(4,.ii$cn.f1.$j.c1) \
                                              -fill white -width 2 -tags dl ]
    }
    if {[expr $ponoff($cn,$j,3)]==1 && [expr $ponoff($cn,$j,5)]==1} {
        set l35(.ii$cn.f1.$j.c1) [ .ii$cn.f1.$j.c1 create line  \
             $xd(3,.ii$cn.f1.$j.c1) $yd(3,.ii$cn.f1.$j.c1) \
             $xd(5,.ii$cn.f1.$j.c1) $yd(5,.ii$cn.f1.$j.c1) \
                                              -fill white -width 2 -tags dl ]
    }
    if {[expr $ponoff($cn,$j,5)]==1 && [expr $ponoff($cn,$j,7)]==1} {
        set l57(.ii$cn.f1.$j.c1) [ .ii$cn.f1.$j.c1 create line  \
             $xd(5,.ii$cn.f1.$j.c1) $yd(5,.ii$cn.f1.$j.c1) \
             $xd(7,.ii$cn.f1.$j.c1) $yd(7,.ii$cn.f1.$j.c1) \
                                              -fill white -width 2 -tags dl ]
    }
    if {[expr $ponoff($cn,$j,7)]==1 && [expr $ponoff($cn,$j,9)]==1} {
        set l79(.ii$cn.f1.$j.c1) [ .ii$cn.f1.$j.c1 create line  \
             $xd(7,.ii$cn.f1.$j.c1) $yd(7,.ii$cn.f1.$j.c1) \
             $xd(9,.ii$cn.f1.$j.c1) $yd(9,.ii$cn.f1.$j.c1) \
                                              -fill white -width 2 -tags dl ]
    }
    if {[expr $ponoff($cn,$j,4)]==1 && [expr $ponoff($cn,$j,6)]==1} {
        set l46(.ii$cn.f1.$j.c1) [ .ii$cn.f1.$j.c1 create line  \
             $xd(4,.ii$cn.f1.$j.c1) $yd(4,.ii$cn.f1.$j.c1) \
             $xd(6,.ii$cn.f1.$j.c1) $yd(6,.ii$cn.f1.$j.c1) \
                                              -fill white -width 2 -tags dl ]
    }
    if {[expr $ponoff($cn,$j,6)]==1 && [expr $ponoff($cn,$j,8)]==1} {
        set l68(.ii$cn.f1.$j.c1) [ .ii$cn.f1.$j.c1 create line  \
             $xd(6,.ii$cn.f1.$j.c1) $yd(6,.ii$cn.f1.$j.c1) \
             $xd(8,.ii$cn.f1.$j.c1) $yd(8,.ii$cn.f1.$j.c1) \
                                              -fill white -width 2 -tags dl ]
    }
    if {[expr $ponoff($cn,$j,8)]==1 && [expr $ponoff($cn,$j,10)]==1} {
        set l810(.ii$cn.f1.$j.c1) [ .ii$cn.f1.$j.c1 create line  \
             $xd(8,.ii$cn.f1.$j.c1) $yd(8,.ii$cn.f1.$j.c1) \
             $xd(10,.ii$cn.f1.$j.c1) $yd(10,.ii$cn.f1.$j.c1) \
                                              -fill white -width 2 -tags dl ]
    }
    if {[expr $ponoff($cn,$j,2)]==1 && [expr $ponoff($cn,$j,11)]==1} {
        set l211(.ii$cn.f1.$j.c1) [ .ii$cn.f1.$j.c1 create line  \
             $xd(2,.ii$cn.f1.$j.c1) $yd(2,.ii$cn.f1.$j.c1) \
             $xd(11,.ii$cn.f1.$j.c1) $yd(11,.ii$cn.f1.$j.c1) \
                                              -fill white -width 2 -tags dl ]
    }
    if {[expr $ponoff($cn,$j,2)]==1 && [expr $ponoff($cn,$j,12)]==1} {
        set l212(.ii$cn.f1.$j.c1) [ .ii$cn.f1.$j.c1 create line  \
             $xd(2,.ii$cn.f1.$j.c1) $yd(2,.ii$cn.f1.$j.c1) \
             $xd(12,.ii$cn.f1.$j.c1) $yd(12,.ii$cn.f1.$j.c1) \
                                              -fill white -width 2 -tags dl ]
    }
    if {[expr $ponoff($cn,$j,11)]==1 && [expr $ponoff($cn,$j,13)]==1} {
        set l1113(.ii$cn.f1.$j.c1) [ .ii$cn.f1.$j.c1 create line  \
             $xd(11,.ii$cn.f1.$j.c1) $yd(11,.ii$cn.f1.$j.c1) \
             $xd(13,.ii$cn.f1.$j.c1) $yd(13,.ii$cn.f1.$j.c1) \
                                              -fill white -width 2 -tags dl ]
    }
    if {[expr $ponoff($cn,$j,13)]==1 && [expr $ponoff($cn,$j,15)]==1} {
        set l1315(.ii$cn.f1.$j.c1) [ .ii$cn.f1.$j.c1 create line  \
             $xd(13,.ii$cn.f1.$j.c1) $yd(13,.ii$cn.f1.$j.c1) \
             $xd(15,.ii$cn.f1.$j.c1) $yd(15,.ii$cn.f1.$j.c1) \
                                              -fill white -width 2 -tags dl ]
    }
    if {[expr $ponoff($cn,$j,15)]==1 && [expr $ponoff($cn,$j,17)]==1} {
        set l1517(.ii$cn.f1.$j.c1) [ .ii$cn.f1.$j.c1 create line  \
             $xd(15,.ii$cn.f1.$j.c1) $yd(15,.ii$cn.f1.$j.c1) \
             $xd(17,.ii$cn.f1.$j.c1) $yd(17,.ii$cn.f1.$j.c1) \
                                              -fill white -width 2 -tags dl ]
    }
    if {[expr $ponoff($cn,$j,12)]==1 && [expr $ponoff($cn,$j,14)]==1} {
        set l1214(.ii$cn.f1.$j.c1) [ .ii$cn.f1.$j.c1 create line  \
             $xd(12,.ii$cn.f1.$j.c1) $yd(12,.ii$cn.f1.$j.c1) \
             $xd(14,.ii$cn.f1.$j.c1) $yd(14,.ii$cn.f1.$j.c1) \
                                              -fill white -width 2 -tags dl ]
    }
    if {[expr $ponoff($cn,$j,14)]==1 && [expr $ponoff($cn,$j,16)]==1} {
        set l1416(.ii$cn.f1.$j.c1) [ .ii$cn.f1.$j.c1 create line  \
             $xd(14,.ii$cn.f1.$j.c1) $yd(14,.ii$cn.f1.$j.c1) \
             $xd(16,.ii$cn.f1.$j.c1) $yd(16,.ii$cn.f1.$j.c1) \
                                              -fill white -width 2 -tags dl ]
    }
    if {[expr $ponoff($cn,$j,16)]==1 && [expr $ponoff($cn,$j,18)]==1} {
        set l1618(.ii$cn.f1.$j.c1) [ .ii$cn.f1.$j.c1 create line  \
             $xd(16,.ii$cn.f1.$j.c1) $yd(16,.ii$cn.f1.$j.c1) \
             $xd(18,.ii$cn.f1.$j.c1) $yd(18,.ii$cn.f1.$j.c1) \
                                              -fill white -width 2 -tags dl ]
    }

    # raise points (ovals)
    catch { .ii$cn.f1.$j.c1 raise dl }
    catch { .ii$cn.f1.$j.c1 raise do }

    # binding
    if {[expr $ponoff($cn,$j,1)]==1} {
    .ii$cn.f1.$j.c1 bind $o1(.ii$cn.f1.$j.c1) <B1-Motion> {
       set xd(1,%W) %x
       set yd(1,%W) %y
       %W coords current \
         [expr $xd(1,%W)-3.0] [expr $yd(1,%W)-3.0] [expr $xd(1,%W)+3.0] [expr $yd(1,%W)+3.0] 
       catch { %W coords $l12(%W) $xd(1,%W) $yd(1,%W) $xd(2,%W) $yd(2,%W) }
    }
    }
    if {[expr $ponoff($cn,$j,2)]==1} {
    .ii$cn.f1.$j.c1 bind $o2(.ii$cn.f1.$j.c1) <B1-Motion> {
       set xd(2,%W) %x
       set yd(2,%W) %y
       %W coords current \
         [expr $xd(2,%W)-3.0] [expr $yd(2,%W)-3.0] [expr $xd(2,%W)+3.0] [expr $yd(2,%W)+3.0] 
       catch { %W coords $l12(%W) $xd(1,%W) $yd(1,%W) $xd(2,%W) $yd(2,%W) }
       catch { %W coords $l23(%W) $xd(2,%W) $yd(2,%W) $xd(3,%W) $yd(3,%W) }
       catch { %W coords $l24(%W) $xd(2,%W) $yd(2,%W) $xd(4,%W) $yd(4,%W) }
       catch { %W coords $l211(%W) $xd(2,%W) $yd(2,%W) $xd(11,%W) $yd(11,%W) }
       catch { %W coords $l212(%W) $xd(2,%W) $yd(2,%W) $xd(12,%W) $yd(12,%W) }
    }
    }
    if {[expr $ponoff($cn,$j,3)]==1} {
    .ii$cn.f1.$j.c1 bind $o3(.ii$cn.f1.$j.c1) <B1-Motion> {
       set xd(3,%W) %x
       set yd(3,%W) %y
       %W coords current \
         [expr $xd(3,%W)-3.0] [expr $yd(3,%W)-3.0] [expr $xd(3,%W)+3.0] [expr $yd(3,%W)+3.0] 
       catch { %W coords $l23(%W) $xd(2,%W) $yd(2,%W) $xd(3,%W) $yd(3,%W) }
       catch { %W coords $l35(%W) $xd(3,%W) $yd(3,%W) $xd(5,%W) $yd(5,%W) }
    }
    }
    if {[expr $ponoff($cn,$j,4)]==1} {
    .ii$cn.f1.$j.c1 bind $o4(.ii$cn.f1.$j.c1) <B1-Motion> {
       set xd(4,%W) %x
       set yd(4,%W) %y
       %W coords current \
         [expr $xd(4,%W)-3.0] [expr $yd(4,%W)-3.0] [expr $xd(4,%W)+3.0] [expr $yd(4,%W)+3.0] 
       catch { %W coords $l24(%W) $xd(2,%W) $yd(2,%W) $xd(4,%W) $yd(4,%W) }
       catch { %W coords $l46(%W) $xd(4,%W) $yd(4,%W) $xd(6,%W) $yd(6,%W) }
    }
    }
    if {[expr $ponoff($cn,$j,5)]==1} {
    .ii$cn.f1.$j.c1 bind $o5(.ii$cn.f1.$j.c1) <B1-Motion> {
       set xd(5,%W) %x
       set yd(5,%W) %y
       %W coords current \
         [expr $xd(5,%W)-3.0] [expr $yd(5,%W)-3.0] [expr $xd(5,%W)+3.0] [expr $yd(5,%W)+3.0] 
       catch { %W coords $l35(%W) $xd(3,%W) $yd(3,%W) $xd(5,%W) $yd(5,%W) }
       catch { %W coords $l57(%W) $xd(5,%W) $yd(5,%W) $xd(7,%W) $yd(7,%W) }
    }
    }
    if {[expr $ponoff($cn,$j,6)]==1} {
    .ii$cn.f1.$j.c1 bind $o6(.ii$cn.f1.$j.c1) <B1-Motion> {
       set xd(6,%W) %x
       set yd(6,%W) %y
       %W coords current \
         [expr $xd(6,%W)-3.0] [expr $yd(6,%W)-3.0] [expr $xd(6,%W)+3.0] [expr $yd(6,%W)+3.0] 
       catch { %W coords $l46(%W) $xd(4,%W) $yd(4,%W) $xd(6,%W) $yd(6,%W) }
       catch { %W coords $l68(%W) $xd(6,%W) $yd(6,%W) $xd(8,%W) $yd(8,%W) }
    }
    }
    if {[expr $ponoff($cn,$j,7)]==1} {
    .ii$cn.f1.$j.c1 bind $o7(.ii$cn.f1.$j.c1) <B1-Motion> {
       set xd(7,%W) %x
       set yd(7,%W) %y
       %W coords current \
         [expr $xd(7,%W)-3.0] [expr $yd(7,%W)-3.0] [expr $xd(7,%W)+3.0] [expr $yd(7,%W)+3.0] 
       catch { %W coords $l57(%W) $xd(5,%W) $yd(5,%W) $xd(7,%W) $yd(7,%W) }
       catch { %W coords $l79(%W) $xd(7,%W) $yd(7,%W) $xd(9,%W) $yd(9,%W) }
    }
    }
    if {[expr $ponoff($cn,$j,8)]==1} {
    .ii$cn.f1.$j.c1 bind $o8(.ii$cn.f1.$j.c1) <B1-Motion> {
       set xd(8,%W) %x
       set yd(8,%W) %y
       %W coords current \
         [expr $xd(8,%W)-3.0] [expr $yd(8,%W)-3.0] [expr $xd(8,%W)+3.0] [expr $yd(8,%W)+3.0] 
       catch { %W coords $l68(%W) $xd(6,%W) $yd(6,%W) $xd(8,%W) $yd(8,%W) }
       catch { %W coords $l810(%W) $xd(8,%W) $yd(8,%W) $xd(10,%W) $yd(10,%W) }
    }
    }
    if {[expr $ponoff($cn,$j,9)]==1} {
    .ii$cn.f1.$j.c1 bind $o9(.ii$cn.f1.$j.c1) <B1-Motion> {
       set xd(9,%W) %x
       set yd(9,%W) %y
       %W coords current \
         [expr $xd(9,%W)-3.0] [expr $yd(9,%W)-3.0] [expr $xd(9,%W)+3.0] [expr $yd(9,%W)+3.0] 
       catch { %W coords $l79(%W) $xd(7,%W) $yd(7,%W) $xd(9,%W) $yd(9,%W) }
    }
    }
    if {[expr $ponoff($cn,$j,10)]==1} {
    .ii$cn.f1.$j.c1 bind $o10(.ii$cn.f1.$j.c1) <B1-Motion> {
       set xd(10,%W) %x
       set yd(10,%W) %y
       %W coords current \
         [expr $xd(10,%W)-3.0] [expr $yd(10,%W)-3.0] [expr $xd(10,%W)+3.0] [expr $yd(10,%W)+3.0] 
       catch { %W coords $l810(%W) $xd(8,%W) $yd(8,%W) $xd(10,%W) $yd(10,%W) }
    }
    }
    if {[expr $ponoff($cn,$j,11)]==1} {
    .ii$cn.f1.$j.c1 bind $o11(.ii$cn.f1.$j.c1) <B1-Motion> {
       set xd(11,%W) %x
       set yd(11,%W) %y
       %W coords current \
         [expr $xd(11,%W)-3.0] [expr $yd(11,%W)-3.0] [expr $xd(11,%W)+3.0] [expr $yd(11,%W)+3.0] 
       catch { %W coords $l211(%W) $xd(2,%W) $yd(2,%W) $xd(11,%W) $yd(11,%W) }
       catch { %W coords $l1113(%W) $xd(11,%W) $yd(11,%W) $xd(13,%W) $yd(13,%W) }
    }
    }
    if {[expr $ponoff($cn,$j,12)]==1} {
    .ii$cn.f1.$j.c1 bind $o12(.ii$cn.f1.$j.c1) <B1-Motion> {
       set xd(12,%W) %x
       set yd(12,%W) %y
       %W coords current \
         [expr $xd(12,%W)-3.0] [expr $yd(12,%W)-3.0] [expr $xd(12,%W)+3.0] [expr $yd(12,%W)+3.0] 
       catch { %W coords $l212(%W) $xd(2,%W) $yd(2,%W) $xd(12,%W) $yd(12,%W) }
       catch { %W coords $l1214(%W) $xd(12,%W) $yd(12,%W) $xd(14,%W) $yd(14,%W) }
    }
    }
    if {[expr $ponoff($cn,$j,13)]==1} {
    .ii$cn.f1.$j.c1 bind $o13(.ii$cn.f1.$j.c1) <B1-Motion> {
       set xd(13,%W) %x
       set yd(13,%W) %y
       %W coords current \
         [expr $xd(13,%W)-3.0] [expr $yd(13,%W)-3.0] [expr $xd(13,%W)+3.0] [expr $yd(13,%W)+3.0] 
       catch { %W coords $l1113(%W) $xd(11,%W) $yd(11,%W) $xd(13,%W) $yd(13,%W) }
       catch { %W coords $l1315(%W) $xd(13,%W) $yd(13,%W) $xd(15,%W) $yd(15,%W) }
    }
    }
    if {[expr $ponoff($cn,$j,14)]==1} {
    .ii$cn.f1.$j.c1 bind $o14(.ii$cn.f1.$j.c1) <B1-Motion> {
       set xd(14,%W) %x
       set yd(14,%W) %y
       %W coords current \
         [expr $xd(14,%W)-3.0] [expr $yd(14,%W)-3.0] [expr $xd(14,%W)+3.0] [expr $yd(14,%W)+3.0] 
       catch { %W coords $l1214(%W) $xd(12,%W) $yd(12,%W) $xd(14,%W) $yd(14,%W) }
       catch { %W coords $l1416(%W) $xd(14,%W) $yd(14,%W) $xd(16,%W) $yd(16,%W) }
    }
    }
    if {[expr $ponoff($cn,$j,15)]==1} {
    .ii$cn.f1.$j.c1 bind $o15(.ii$cn.f1.$j.c1) <B1-Motion> {
       set xd(15,%W) %x
       set yd(15,%W) %y
       %W coords current \
         [expr $xd(15,%W)-3.0] [expr $yd(15,%W)-3.0] [expr $xd(15,%W)+3.0] [expr $yd(15,%W)+3.0] 
       catch { %W coords $l1315(%W) $xd(13,%W) $yd(13,%W) $xd(15,%W) $yd(15,%W) }
       catch { %W coords $l1517(%W) $xd(15,%W) $yd(15,%W) $xd(17,%W) $yd(17,%W) }
    }
    }
    if {[expr $ponoff($cn,$j,16)]==1} {
    .ii$cn.f1.$j.c1 bind $o16(.ii$cn.f1.$j.c1) <B1-Motion> {
       set xd(16,%W) %x
       set yd(16,%W) %y
       %W coords current \
         [expr $xd(16,%W)-3.0] [expr $yd(16,%W)-3.0] [expr $xd(16,%W)+3.0] [expr $yd(16,%W)+3.0] 
       catch { %W coords $l1416(%W) $xd(14,%W) $yd(14,%W) $xd(16,%W) $yd(16,%W) }
       catch { %W coords $l1618(%W) $xd(16,%W) $yd(16,%W) $xd(18,%W) $yd(18,%W) }
    }
    }
    if {[expr $ponoff($cn,$j,17)]==1} {
    .ii$cn.f1.$j.c1 bind $o17(.ii$cn.f1.$j.c1) <B1-Motion> {
       set xd(17,%W) %x
       set yd(17,%W) %y
       %W coords current \
         [expr $xd(17,%W)-3.0] [expr $yd(17,%W)-3.0] [expr $xd(17,%W)+3.0] [expr $yd(17,%W)+3.0] 
       catch { %W coords $l1517(%W) $xd(15,%W) $yd(15,%W) $xd(17,%W) $yd(17,%W) }
    }
    }
    if {[expr $ponoff($cn,$j,18)]==1} {
    .ii$cn.f1.$j.c1 bind $o18(.ii$cn.f1.$j.c1) <B1-Motion> {
       set xd(18,%W) %x
       set yd(18,%W) %y
       %W coords current \
         [expr $xd(18,%W)-3.0] [expr $yd(18,%W)-3.0] [expr $xd(18,%W)+3.0] [expr $yd(18,%W)+3.0] 
       catch { %W coords $l1618(%W) $xd(16,%W) $yd(16,%W) $xd(18,%W) $yd(18,%W) }
    }
    }
}


proc LoadDigitize { } {
    global num_frames
    global donoff ponoff xd yd

    if {[file exists digitize.dat]==1} {
        set f [open digitize.dat r]
        gets $f line

        for {set cn 1} {$cn<=4} {incr cn} {
            for {set j 0} {$j<$num_frames} {incr j} {
                gets $f donoff($cn,$j)
                for {set k 1} {$k<=18} {incr k} {
                    gets $f ponoff($cn,$j,$k)
                }
                for {set k 1} {$k<=18} {incr k} {
                    gets $f line
                    set xd($k,.ii$cn.f1.$j.c1) [lindex $line 0]
                    set yd($k,.ii$cn.f1.$j.c1) [lindex $line 1]
                }
            }
        }
    }
}


proc ApplyNextDigitize { cn j } {
    global donoff ponoff xd yd
    set jp [expr $j+1]
    set donoff($cn,$jp) $donoff($cn,$j)
    for {set k 1} {$k<=18} {incr k} {
        set ponoff($cn,$jp,$k) $ponoff($cn,$j,$k)
        set xd($k,.ii$cn.f1.$jp.c1) $xd($k,.ii$cn.f1.$j.c1) 
        set yd($k,.ii$cn.f1.$jp.c1) $yd($k,.ii$cn.f1.$j.c1)
    }
    DrawDigitize $cn $jp
}


proc ApplyPreviousDigitize { cn j } {
    global donoff ponoff xd yd
    set jm [expr $j-1]
    set donoff($cn,$jm) $donoff($cn,$j)
    for {set k 1} {$k<=18} {incr k} {
        set ponoff($cn,$jm,$k) $ponoff($cn,$j,$k)
        set xd($k,.ii$cn.f1.$jm.c1) $xd($k,.ii$cn.f1.$j.c1) 
        set yd($k,.ii$cn.f1.$jm.c1) $yd($k,.ii$cn.f1.$j.c1)
    }
    DrawDigitize $cn $jm
}


proc AutoAdjustAngle { edm_num act_line } {
    global ajm_time xaa
    set xaa [.editejm$edm_num.value.text.e[expr $ajm_time +1] get]
    OpenAutoAdjust $edm_num $act_line
}


# Open Auto Adjust Window
proc OpenAutoAdjust { edm_num act_line } {
    if {[winfo exists .aa]==0} {
    global Digitize Head_top Neck R_shoulder L_shoulder R_elbow L_elbow \
           R_wrist L_wrist R_hand_tip L_hand_tip R_hip L_hip R_knee L_knee \
           R_ankle L_ankle R_toe L_toe

    toplevel .aa
    wm protocol .aa WM_DELETE_WINDOW "wm withdraw .aa"
    wm title .aa "Swumsuit: Auto Adjust"

    label .aa.0 -text "1     2     3     4   "
    pack .aa.0 -side top -anchor e

    global All_on All_off
    frame .aa.aon
    label .aa.aon.l -text "$All_on" -width 10 -anchor w
    checkbutton .aa.aon.c1  -variable aacbon(1) -command "AutoAdjustAllOn 1"
    checkbutton .aa.aon.c2  -variable aacbon(2) -command "AutoAdjustAllOn 2"
    checkbutton .aa.aon.c3  -variable aacbon(3) -command "AutoAdjustAllOn 3"
    checkbutton .aa.aon.c4  -variable aacbon(4) -command "AutoAdjustAllOn 4"
    pack .aa.aon.l -padx 2 -side left
    pack .aa.aon.c1 .aa.aon.c2 .aa.aon.c3 .aa.aon.c4 -side left
    pack .aa.aon -side top
    frame .aa.aoff
    label .aa.aoff.l -text "$All_off" -width 10 -anchor w
    checkbutton .aa.aoff.c1  -variable aacboff(1) -command "AutoAdjustAllOff 1"
    checkbutton .aa.aoff.c2  -variable aacboff(2) -command "AutoAdjustAllOff 2"
    checkbutton .aa.aoff.c3  -variable aacboff(3) -command "AutoAdjustAllOff 3"
    checkbutton .aa.aoff.c4  -variable aacboff(4) -command "AutoAdjustAllOff 4"
    pack .aa.aoff.l -padx 2 -side left
    pack .aa.aoff.c1 .aa.aoff.c2 .aa.aoff.c3 .aa.aoff.c4 -side left
    pack .aa.aoff -side top



    set ptext "Head_top Neck R_shoulder L_shoulder R_elbow L_elbow R_wrist L_wrist R_hand_tip L_hand_tip R_hip L_hip R_knee L_knee R_ankle L_ankle R_toe L_toe"

    for {set k 1} {$k<=18} {incr k} {
        frame .aa.$k
        label .aa.$k.l -text [expr $[lindex $ptext [expr $k-1]]] -width 10 -anchor w
        checkbutton .aa.$k.c1 -variable aacb($k,1) -command "AutoAdjustAllCheck 1"
        checkbutton .aa.$k.c2 -variable aacb($k,2) -command "AutoAdjustAllCheck 2"
        checkbutton .aa.$k.c3 -variable aacb($k,3) -command "AutoAdjustAllCheck 3"
        checkbutton .aa.$k.c4 -variable aacb($k,4) -command "AutoAdjustAllCheck 4"
        pack .aa.$k.l -padx 2 -side left
        pack .aa.$k.c1 .aa.$k.c2 .aa.$k.c3 .aa.$k.c4 -side left
        pack .aa.$k -side top
    }
   
    global Step aastep
    frame .aa.step
    label .aa.step.l -text "$Step : "
    entry .aa.step.e -textvariable aastep -width 12
    global aastep
    set aastep 1.0
    pack  .aa.step.l .aa.step.e -side left
    pack  .aa.step -side top -anchor w -pady 5

    global Apply_for_current_frame Apply_for_all_frames Cancel Apply Close
    frame .aa.oc -relief flat -bd 2
    #button .aa.oc.ac     -text $Apply_for_current_frame -command "StartAutoAdjust $edm_num $act_line"
    #button .aa.oc.aa     -text $Apply_for_all_frames
    button .aa.oc.ac     -text $Apply -command "StartAutoAdjust $edm_num $act_line"
    button .aa.oc.cancel -text $Close -command "wm withdraw .aa"
    #pack .aa.oc.ac .aa.oc.aa .aa.oc.cancel  -side top -pady 5
    pack .aa.oc.ac      -side left  -pady 5 -padx 20
    pack .aa.oc.cancel  -side right -pady 5 -padx 20
    pack .aa.oc -side top -pady 0 -expand 1 -fill x
    
    ChangeIcon .aa

    } else {
        wm deiconify .aa
        .aa.oc.ac configure -command "StartAutoAdjust $edm_num $act_line"
    }
}


# Start Auto Adjust
proc StartAutoAdjust { edm_num act_line} {
    global xaa ajm_time xscr yscr aacb xd yd aastep

    set xaa [.editejm$edm_num.value.text.e[expr $ajm_time +1] get]

    if {[winfo exists .aagoing]==0} {
        toplevel .aagoing
        wm protocol .aagoing WM_DELETE_WINDOW "wm withdraw .aagoing"
        wm title .aagoing "Swumsuit: Auto adjusting..."
        ChangeIcon .aagoing
        global Auto_adjusting
        label .aagoing.label -text "$Auto_adjusting"
        pack .aagoing.label -side top -anchor e -padx 20 -pady 20
        update
    } else {
        wm deiconify .aagoing
        update
    }

    # first, calculate the value at xaa 
    set vaa 0
    for {set cn 1} {$cn<=4} {incr cn} {
    for {set k  1} {$k<=18} {incr k} {
        if {$aacb($k,$cn)==1} {
            set vaa [expr $vaa + pow(($xscr($cn,$ajm_time,$k)-$xd($k,.ii$cn.f1.$ajm_time.c1)),2) \
                               + pow(($yscr($cn,$ajm_time,$k)-$yd($k,.ii$cn.f1.$ajm_time.c1)),2)]
        }
    }
    }

    # next, test positive direction
    .editejm$edm_num.value.text.e[expr $ajm_time +1] delete 0 end
    .editejm$edm_num.value.text.e[expr $ajm_time +1] insert 0 [expr $xaa + $aastep]
    ChangeAllListValues $edm_num $act_line
    ChangeJointMotionGraph $edm_num
    StoreJointMotion
    IISwimmerUpdate

    set vaap 0
    for {set cn 1} {$cn<=4} {incr cn} {
    for {set k  1} {$k<=18} {incr k} {
        if {$aacb($k,$cn)==1} {
            set vaap [expr $vaap + pow(($xscr($cn,$ajm_time,$k)-$xd($k,.ii$cn.f1.$ajm_time.c1)),2) \
                                 + pow(($yscr($cn,$ajm_time,$k)-$yd($k,.ii$cn.f1.$ajm_time.c1)),2)]
        }
    }
    }

    # next, test negative direction
    .editejm$edm_num.value.text.e[expr $ajm_time +1] delete 0 end
    .editejm$edm_num.value.text.e[expr $ajm_time +1] insert 0 [expr $xaa - $aastep]
    ChangeAllListValues $edm_num $act_line
    ChangeJointMotionGraph $edm_num
    StoreJointMotion
    IISwimmerUpdate

    set vaan 0
    for {set cn 1} {$cn<=4} {incr cn} {
    for {set k  1} {$k<=18} {incr k} {
        if {$aacb($k,$cn)==1} {
            set vaan [expr $vaan + pow(($xscr($cn,$ajm_time,$k)-$xd($k,.ii$cn.f1.$ajm_time.c1)),2) \
                                 + pow(($yscr($cn,$ajm_time,$k)-$yd($k,.ii$cn.f1.$ajm_time.c1)),2)]
        }
    }
    }

    # determine the direction to proceed
    if {$vaa<=$vaap && $vaa<=$vaan} {
        # return to xaa
        .editejm$edm_num.value.text.e[expr $ajm_time +1] delete 0 end
        .editejm$edm_num.value.text.e[expr $ajm_time +1] insert 0 $xaa
        ChangeAllListValues $edm_num $act_line
        ChangeJointMotionGraph $edm_num
        StoreJointMotion
        IISwimmerUpdate
        #wm withdraw .aa
        wm withdraw .aagoing
        return
    } elseif {$vaap<$vaan} {
        set xdirec 1.0
        set xaa [expr $xaa + $aastep]
        set vaadold $vaap
    } else {
        set xdirec -1.0
        set xaa [expr $xaa - $aastep]
        set vaadold $vaan
    }

    # proceed in the determined direction
    for {set i 1} {$i<1000000000} {incr i} {
        .editejm$edm_num.value.text.e[expr $ajm_time +1] delete 0 end
        .editejm$edm_num.value.text.e[expr $ajm_time +1] insert 0 [expr $xaa + $xdirec * $aastep]
        ChangeAllListValues $edm_num $act_line
        ChangeJointMotionGraph $edm_num
        StoreJointMotion
        IISwimmerUpdate
        update
        set vaad 0
        for {set cn 1} {$cn<=4} {incr cn} {
        for {set k  1} {$k<=18} {incr k} {
            if {$aacb($k,$cn)==1} {
                set vaad [expr $vaad + pow(($xscr($cn,$ajm_time,$k)-$xd($k,.ii$cn.f1.$ajm_time.c1)),2) \
                                     + pow(($yscr($cn,$ajm_time,$k)-$yd($k,.ii$cn.f1.$ajm_time.c1)),2)]
            }
        }
        }

        if {$vaad > $vaadold} {
            .editejm$edm_num.value.text.e[expr $ajm_time +1] delete 0 end
            .editejm$edm_num.value.text.e[expr $ajm_time +1] insert 0 $xaa
            ChangeAllListValues $edm_num $act_line
            ChangeJointMotionGraph $edm_num
            StoreJointMotion
            IISwimmerUpdate
            update
            #wm withdraw .aa
            wm withdraw .aagoing
            return
        } else {
            set vaadold $vaad
            set xaa [expr $xaa + $xdirec * $aastep]
        }
    }
}


# Open Auto Adjust for Image
proc OpenAutoAdjustImage { cn j } {
    if {[winfo exists .aai]==0} {
    global Digitize Head_top Neck R_shoulder L_shoulder R_elbow L_elbow \
           R_wrist L_wrist R_hand_tip L_hand_tip R_hip L_hip R_knee L_knee \
           R_ankle L_ankle R_toe L_toe

    toplevel .aai
    wm protocol .aai WM_DELETE_WINDOW "wm withdraw .aai"
    wm title .aai "Swumsuit: Auto Adjust"

    label .aai.0 -text "1     2     3     4   "
    pack .aai.0 -side top -anchor e

    global All_on All_off
    frame .aai.aon
    label .aai.aon.l -text "$All_on" -width 10 -anchor w
    checkbutton .aai.aon.c1  -variable aacbon(1) -command "AutoAdjustAllOn 1"
    checkbutton .aai.aon.c2  -variable aacbon(2) -command "AutoAdjustAllOn 2"
    checkbutton .aai.aon.c3  -variable aacbon(3) -command "AutoAdjustAllOn 3"
    checkbutton .aai.aon.c4  -variable aacbon(4) -command "AutoAdjustAllOn 4"
    pack .aai.aon.l -padx 2 -side left
    pack .aai.aon.c1 .aai.aon.c2 .aai.aon.c3 .aai.aon.c4 -side left
    pack .aai.aon -side top
    frame .aai.aoff
    label .aai.aoff.l -text "$All_off" -width 10 -anchor w
    checkbutton .aai.aoff.c1  -variable aacboff(1) -command "AutoAdjustAllOff 1"
    checkbutton .aai.aoff.c2  -variable aacboff(2) -command "AutoAdjustAllOff 2"
    checkbutton .aai.aoff.c3  -variable aacboff(3) -command "AutoAdjustAllOff 3"
    checkbutton .aai.aoff.c4  -variable aacboff(4) -command "AutoAdjustAllOff 4"
    pack .aai.aoff.l -padx 2 -side left
    pack .aai.aoff.c1 .aai.aoff.c2 .aai.aoff.c3 .aai.aoff.c4 -side left
    pack .aai.aoff -side top


    set ptext "Head_top Neck R_shoulder L_shoulder R_elbow L_elbow R_wrist L_wrist R_hand_tip L_hand_tip R_hip L_hip R_knee L_knee R_ankle L_ankle R_toe L_toe"

    for {set k 1} {$k<=18} {incr k} {
        frame .aai.$k
        label .aai.$k.l -text [expr $[lindex $ptext [expr $k-1]]] -width 10 -anchor w
        checkbutton .aai.$k.c1 -variable aacb($k,1) -command "AutoAdjustAllCheck 1"
        checkbutton .aai.$k.c2 -variable aacb($k,2) -command "AutoAdjustAllCheck 2"
        checkbutton .aai.$k.c3 -variable aacb($k,3) -command "AutoAdjustAllCheck 3"
        checkbutton .aai.$k.c4 -variable aacb($k,4) -command "AutoAdjustAllCheck 4"
        pack .aai.$k.l -padx 2 -side left
        pack .aai.$k.c1 .aai.$k.c2 .aai.$k.c3 .aai.$k.c4 -side left
        pack .aai.$k -side top
    }
   
    global Step aastep
    frame .aai.step
    label .aai.step.l -text "$Step : "
    entry .aai.step.e -textvariable aastep -width 12
    global aastep
    set aastep 1.0
    pack  .aai.step.l .aai.step.e -side left
    pack  .aai.step -side top -anchor w -pady 5

    global H_shift V_shift Magnify2
    frame .aai.select
    radiobutton .aai.select.hshift -text $H_shift  -variable itype -value 0
    radiobutton .aai.select.vshift -text $V_shift  -variable itype -value 1
    radiobutton .aai.select.mag    -text $Magnify2 -variable itype -value 2
    pack .aai.select.hshift .aai.select.vshift .aai.select.mag -side top -anchor w
    pack .aai.select -side top 

    global Apply_for_current_frame Apply_for_all_frames Cancel Apply Close
    frame .aai.oc -relief flat -bd 2
    button .aai.oc.ac     -text $Apply -command "StartAutoAdjustImage $cn"
    button .aai.oc.cancel -text $Close -command "wm withdraw .aai"
    pack .aai.oc.ac      -side left  -pady 5 -padx 20
    pack .aai.oc.cancel  -side right -pady 5 -padx 20
    pack .aai.oc -side top -pady 0 -expand 1 -fill x
    
    ChangeIcon .aai

    } else {
        wm deiconify .aai
        .aai.oc.ac configure -command "StartAutoAdjustImage $cn"
    }
}


# Start Auto Adjust for Image
proc StartAutoAdjustImage { cn } {
    global xaa xscr yscr aacb xd yd aastep itype ajm_time
    set j $ajm_time

    if {[winfo exists .aagoing]==0} {
        toplevel .aagoing
        wm protocol .aagoing WM_DELETE_WINDOW "wm withdraw .aagoing"
        wm title .aagoing "Swumsuit: Auto adjusting..."
        ChangeIcon .aagoing
        global Auto_adjusting
        label .aagoing.label -text "$Auto_adjusting"
        pack .aagoing.label -side top -anchor e -padx 20 -pady 20
        update
    } else {
        wm deiconify .aagoing
        update
    }

    # first, calculate the value at xaa 
    set vaa 0
    for {set k  1} {$k<=18} {incr k} {
        if {$aacb($k,$cn)==1} {
            set vaa [expr $vaa + pow(($xscr($cn,$j,$k)-$xd($k,.ii$cn.f1.$j.c1)),2) \
                               + pow(($yscr($cn,$j,$k)-$yd($k,.ii$cn.f1.$j.c1)),2)]
        }
    }

    # next, test positive direction
    if {$itype==0} {
        set xaa [.ii$cn.f1.$j.f2.e2 get]
        .ii$cn.f1.$j.f2.e2 delete 0 end
        .ii$cn.f1.$j.f2.e2 insert 0 [expr $xaa + $aastep]
    } elseif {$itype==1} {
        set xaa [.ii$cn.f1.$j.f2.e3 get]
        .ii$cn.f1.$j.f2.e3 delete 0 end
        .ii$cn.f1.$j.f2.e3 insert 0 [expr $xaa + $aastep]
    } else {
        set xaa [.ii$cn.f1.$j.f2.e1 get]
        .ii$cn.f1.$j.f2.e1 delete 0 end
        .ii$cn.f1.$j.f2.e1 insert 0 [expr $xaa + $aastep]
    }
    ChangeImageSize $cn $j
    ChangeImageLocation $cn $j

    set vaap 0
    for {set k  1} {$k<=18} {incr k} {
        if {$aacb($k,$cn)==1} {
            set vaap [expr $vaap + pow(($xscr($cn,$j,$k)-$xd($k,.ii$cn.f1.$j.c1)),2) \
                                 + pow(($yscr($cn,$j,$k)-$yd($k,.ii$cn.f1.$j.c1)),2)]
        }
    }

    # next, test negative direction
    if {$itype==0} {
        .ii$cn.f1.$j.f2.e2 delete 0 end
        .ii$cn.f1.$j.f2.e2 insert 0 [expr $xaa - $aastep]
    } elseif {$itype==1} {
        .ii$cn.f1.$j.f2.e3 delete 0 end
        .ii$cn.f1.$j.f2.e3 insert 0 [expr $xaa - $aastep]
    } else {
        .ii$cn.f1.$j.f2.e1 delete 0 end
        .ii$cn.f1.$j.f2.e1 insert 0 [expr $xaa - $aastep]
    }
    ChangeImageSize $cn $j
    ChangeImageLocation $cn $j

    set vaan 0
    for {set k  1} {$k<=18} {incr k} {
        if {$aacb($k,$cn)==1} {
            set vaan [expr $vaan + pow(($xscr($cn,$j,$k)-$xd($k,.ii$cn.f1.$j.c1)),2) \
                                 + pow(($yscr($cn,$j,$k)-$yd($k,.ii$cn.f1.$j.c1)),2)]
        }
    }

    # determine the direction to proceed
    if {$vaa<=$vaap && $vaa<=$vaan} {
        # return to xaa
        if {$itype==0} {
            .ii$cn.f1.$j.f2.e2 delete 0 end
            .ii$cn.f1.$j.f2.e2 insert 0 $xaa
        } elseif {$itype==1} {
            .ii$cn.f1.$j.f2.e3 delete 0 end
            .ii$cn.f1.$j.f2.e3 insert 0 $xaa
        } else {
            .ii$cn.f1.$j.f2.e1 delete 0 end
            .ii$cn.f1.$j.f2.e1 insert 0 $xaa
        }
        ChangeImageSize $cn $j
        ChangeImageLocation $cn $j
        #wm withdraw .aai
        wm withdraw .aagoing
        return
    } elseif {$vaap<$vaan} {
        set xdirec 1.0
        set xaa [expr $xaa + $aastep]
        set vaadold $vaap
    } else {
        set xdirec -1.0
        set xaa [expr $xaa - $aastep]
        set vaadold $vaan
    }

    # proceed in the determined direction
    for {set i 1} {$i<1000000000} {incr i} {
        if {$itype==0} {
            .ii$cn.f1.$j.f2.e2 delete 0 end
            .ii$cn.f1.$j.f2.e2 insert 0 [expr $xaa + $xdirec * $aastep]
        } elseif {$itype==1} {
            .ii$cn.f1.$j.f2.e3 delete 0 end
            .ii$cn.f1.$j.f2.e3 insert 0 [expr $xaa + $xdirec * $aastep]
        } else {
            .ii$cn.f1.$j.f2.e1 delete 0 end
            .ii$cn.f1.$j.f2.e1 insert 0 [expr $xaa + $xdirec * $aastep]
        }
        ChangeImageSize $cn $j
        ChangeImageLocation $cn $j
        update
        set vaad 0
        for {set k  1} {$k<=18} {incr k} {
            if {$aacb($k,$cn)==1} {
                set vaad [expr $vaad + pow(($xscr($cn,$j,$k)-$xd($k,.ii$cn.f1.$j.c1)),2) \
                                     + pow(($yscr($cn,$j,$k)-$yd($k,.ii$cn.f1.$j.c1)),2)]
            }
        }

        if {$vaad > $vaadold} {
            if {$itype==0} {
                .ii$cn.f1.$j.f2.e2 delete 0 end
                .ii$cn.f1.$j.f2.e2 insert 0 $xaa
            } elseif {$itype==1} {
                .ii$cn.f1.$j.f2.e3 delete 0 end
                .ii$cn.f1.$j.f2.e3 insert 0 $xaa 
            } else {
                .ii$cn.f1.$j.f2.e1 delete 0 end
                .ii$cn.f1.$j.f2.e1 insert 0 $xaa
            }
            ChangeImageSize $cn $j
            ChangeImageLocation $cn $j
            update
            #wm withdraw .aai
            wm withdraw .aagoing
            return
        } else {
            set vaadold $vaad
            set xaa [expr $xaa + $xdirec * $aastep]
        }
    }
}


# Open Auto Adjust for Model
proc OpenAutoAdjustModel { cn j } {
    if {[winfo exists .aam]==0} {
    global Digitize Head_top Neck R_shoulder L_shoulder R_elbow L_elbow \
           R_wrist L_wrist R_hand_tip L_hand_tip R_hip L_hip R_knee L_knee \
           R_ankle L_ankle R_toe L_toe

    toplevel .aam
    wm protocol .aam WM_DELETE_WINDOW "wm withdraw .aam"
    wm title .aam "Swumsuit: Auto Adjust"

    label .aam.0 -text "1     2     3     4   "
    pack .aam.0 -side top -anchor e

    global All_on All_off
    frame .aam.aon
    label .aam.aon.l -text "$All_on" -width 10 -anchor w
    checkbutton .aam.aon.c1  -variable aacbon(1) -command "AutoAdjustAllOn 1"
    checkbutton .aam.aon.c2  -variable aacbon(2) -command "AutoAdjustAllOn 2"
    checkbutton .aam.aon.c3  -variable aacbon(3) -command "AutoAdjustAllOn 3"
    checkbutton .aam.aon.c4  -variable aacbon(4) -command "AutoAdjustAllOn 4"
    pack .aam.aon.l -padx 2 -side left
    pack .aam.aon.c1 .aam.aon.c2 .aam.aon.c3 .aam.aon.c4 -side left
    pack .aam.aon -side top
    frame .aam.aoff
    label .aam.aoff.l -text "$All_off" -width 10 -anchor w
    checkbutton .aam.aoff.c1  -variable aacboff(1) -command "AutoAdjustAllOff 1"
    checkbutton .aam.aoff.c2  -variable aacboff(2) -command "AutoAdjustAllOff 2"
    checkbutton .aam.aoff.c3  -variable aacboff(3) -command "AutoAdjustAllOff 3"
    checkbutton .aam.aoff.c4  -variable aacboff(4) -command "AutoAdjustAllOff 4"
    pack .aam.aoff.l -padx 2 -side left
    pack .aam.aoff.c1 .aam.aoff.c2 .aam.aoff.c3 .aam.aoff.c4 -side left
    pack .aam.aoff -side top



    set ptext "Head_top Neck R_shoulder L_shoulder R_elbow L_elbow R_wrist L_wrist R_hand_tip L_hand_tip R_hip L_hip R_knee L_knee R_ankle L_ankle R_toe L_toe"

    for {set k 1} {$k<=18} {incr k} {
        frame .aam.$k
        label .aam.$k.l -text [expr $[lindex $ptext [expr $k-1]]] -width 10 -anchor w
        checkbutton .aam.$k.c1 -variable aacb($k,1) -command "AutoAdjustAllCheck 1"
        checkbutton .aam.$k.c2 -variable aacb($k,2) -command "AutoAdjustAllCheck 2"
        checkbutton .aam.$k.c3 -variable aacb($k,3) -command "AutoAdjustAllCheck 3"
        checkbutton .aam.$k.c4 -variable aacb($k,4) -command "AutoAdjustAllCheck 4"
        pack .aam.$k.l -padx 2 -side left
        pack .aam.$k.c1 .aam.$k.c2 .aam.$k.c3 .aam.$k.c4 -side left
        pack .aam.$k -side top
    }
   
    global Step aastep
    frame .aam.step
    label .aam.step.l -text "$Step : "
    entry .aam.step.e -textvariable aastep -width 12
    global aastep
    set aastep 1.0
    pack  .aam.step.l .aam.step.e -side left
    pack  .aam.step -side top -anchor w -pady 5

    global X_angle Y_angle Z_angle Magnify2 Distance2
    frame .aam.select
    radiobutton .aam.select.xangle -text $X_angle   -variable mtype -value 0
    radiobutton .aam.select.yangle -text $Y_angle   -variable mtype -value 1
    radiobutton .aam.select.zangle -text $Z_angle   -variable mtype -value 2
    radiobutton .aam.select.mag    -text $Magnify2  -variable mtype -value 3
    radiobutton .aam.select.dist   -text $Distance2 -variable mtype -value 4
    pack .aam.select.xangle .aam.select.yangle .aam.select.zangle \
         .aam.select.mag .aam.select.dist -side top -anchor w
    pack .aam.select -side top 

    global Apply_for_current_frame Apply_for_all_frames Cancel Apply Close
    frame .aam.oc -relief flat -bd 2
    button .aam.oc.ac     -text $Apply -command "StartAutoAdjustModel $cn"
    button .aam.oc.cancel -text $Close -command "wm withdraw .aam"
    pack .aam.oc.ac      -side left  -pady 5 -padx 20
    pack .aam.oc.cancel  -side right -pady 5 -padx 20
    pack .aam.oc -side top -pady 0 -expand 1 -fill x
    
    ChangeIcon .aam

    } else {
        wm deiconify .aam
        .aam.oc.ac configure -command "StartAutoAdjustModel $cn"
    }
}


# Start Auto Adjust for Model
proc StartAutoAdjustModel { cn } {
    global xaa xscr yscr aacb xd yd aastep mtype ajm_time
    set j $ajm_time

    if {[winfo exists .aagoing]==0} {
        toplevel .aagoing
        wm protocol .aagoing WM_DELETE_WINDOW "wm withdraw .aagoing"
        wm title .aagoing "Swumsuit: Auto adjusting..."
        ChangeIcon .aagoing
        global Auto_adjusting
        label .aagoing.label -text "$Auto_adjusting"
        pack .aagoing.label -side top -anchor e -padx 20 -pady 20
        update
    } else {
        wm deiconify .aagoing
        update
    }

    # first, calculate the value at xaa 
    set vaa 0
    for {set k  1} {$k<=18} {incr k} {
        if {$aacb($k,$cn)==1} {
            set vaa [expr $vaa + pow(($xscr($cn,$j,$k)-$xd($k,.ii$cn.f1.$j.c1)),2) \
                               + pow(($yscr($cn,$j,$k)-$yd($k,.ii$cn.f1.$j.c1)),2)]
        }
    }

    # next, test positive direction
    if {$mtype==0} {
        set xaa [.ii$cn.f1.$j.f3.e4 get]
        .ii$cn.f1.$j.f3.e4 delete 0 end
        .ii$cn.f1.$j.f3.e4 insert 0 [expr $xaa + $aastep]
    } elseif {$mtype==1} {
        set xaa [.ii$cn.f1.$j.f3.e5 get]
        .ii$cn.f1.$j.f3.e5 delete 0 end
        .ii$cn.f1.$j.f3.e5 insert 0 [expr $xaa + $aastep]
    } elseif {$mtype==2} {
        set xaa [.ii$cn.f1.$j.f3.e6 get]
        .ii$cn.f1.$j.f3.e6 delete 0 end
        .ii$cn.f1.$j.f3.e6 insert 0 [expr $xaa + $aastep]
    } elseif {$mtype==3} {
        set xaa [.ii$cn.f1.$j.f3.e7 get]
        .ii$cn.f1.$j.f3.e7 delete 0 end
        .ii$cn.f1.$j.f3.e7 insert 0 [expr $xaa + $aastep]
    } else {
        set xaa [.ii$cn.f1.$j.f3.e8 get]
        .ii$cn.f1.$j.f3.e8 delete 0 end
        .ii$cn.f1.$j.f3.e8 insert 0 [expr $xaa + $aastep]
    }
    IIRot $cn $j

    set vaap 0
    for {set k  1} {$k<=18} {incr k} {
        if {$aacb($k,$cn)==1} {
            set vaap [expr $vaap + pow(($xscr($cn,$j,$k)-$xd($k,.ii$cn.f1.$j.c1)),2) \
                                 + pow(($yscr($cn,$j,$k)-$yd($k,.ii$cn.f1.$j.c1)),2)]
        }
    }

    # next, test negative direction
    if {$mtype==0} {
        .ii$cn.f1.$j.f3.e4 delete 0 end
        .ii$cn.f1.$j.f3.e4 insert 0 [expr $xaa - $aastep]
    } elseif {$mtype==1} {
        .ii$cn.f1.$j.f3.e5 delete 0 end
        .ii$cn.f1.$j.f3.e5 insert 0 [expr $xaa - $aastep]
    } elseif {$mtype==2} {
        .ii$cn.f1.$j.f3.e6 delete 0 end
        .ii$cn.f1.$j.f3.e6 insert 0 [expr $xaa - $aastep]
    } elseif {$mtype==3} {
        .ii$cn.f1.$j.f3.e7 delete 0 end
        .ii$cn.f1.$j.f3.e7 insert 0 [expr $xaa - $aastep]
    } else {
        .ii$cn.f1.$j.f3.e8 delete 0 end
        .ii$cn.f1.$j.f3.e8 insert 0 [expr $xaa - $aastep]
    }
    IIRot $cn $j

    set vaan 0
    for {set k  1} {$k<=18} {incr k} {
        if {$aacb($k,$cn)==1} {
            set vaan [expr $vaan + pow(($xscr($cn,$j,$k)-$xd($k,.ii$cn.f1.$j.c1)),2) \
                                 + pow(($yscr($cn,$j,$k)-$yd($k,.ii$cn.f1.$j.c1)),2)]
        }
    }

    # determine the direction to proceed
    if {$vaa<=$vaap && $vaa<=$vaan} {
        # return to xaa
        if {$mtype==0} {
            .ii$cn.f1.$j.f3.e4 delete 0 end
            .ii$cn.f1.$j.f3.e4 insert 0 $xaa
        } elseif {$mtype==1} {
            .ii$cn.f1.$j.f3.e5 delete 0 end
            .ii$cn.f1.$j.f3.e5 insert 0 $xaa
        } elseif {$mtype==2} {
            .ii$cn.f1.$j.f3.e6 delete 0 end
            .ii$cn.f1.$j.f3.e6 insert 0 $xaa
        } elseif {$mtype==3} {
            .ii$cn.f1.$j.f3.e7 delete 0 end
            .ii$cn.f1.$j.f3.e7 insert 0 $xaa
        } else {
            .ii$cn.f1.$j.f3.e8 delete 0 end
            .ii$cn.f1.$j.f3.e8 insert 0 $xaa
        }
        IIRot $cn $j
        #wm withdraw .aam
        wm withdraw .aagoing
        return
    } elseif {$vaap<$vaan} {
        set xdirec 1.0
        set xaa [expr $xaa + $aastep]
        set vaadold $vaap
    } else {
        set xdirec -1.0
        set xaa [expr $xaa - $aastep]
        set vaadold $vaan
    }

    # proceed in the determined direction
    for {set i 1} {$i<1000000000} {incr i} {
        if {$mtype==0} {
            .ii$cn.f1.$j.f3.e4 delete 0 end
            .ii$cn.f1.$j.f3.e4 insert 0 [expr $xaa + $xdirec * $aastep]
        } elseif {$mtype==1} {
            .ii$cn.f1.$j.f3.e5 delete 0 end
            .ii$cn.f1.$j.f3.e5 insert 0 [expr $xaa + $xdirec * $aastep]
        } elseif {$mtype==2} {
            .ii$cn.f1.$j.f3.e6 delete 0 end
            .ii$cn.f1.$j.f3.e6 insert 0 [expr $xaa + $xdirec * $aastep]
        } elseif {$mtype==3} {
            .ii$cn.f1.$j.f3.e7 delete 0 end
            .ii$cn.f1.$j.f3.e7 insert 0 [expr $xaa + $xdirec * $aastep]
        } else {
            .ii$cn.f1.$j.f3.e8 delete 0 end
            .ii$cn.f1.$j.f3.e8 insert 0 [expr $xaa + $xdirec * $aastep]
        }
        IIRot $cn $j
        update
        set vaad 0
        for {set k  1} {$k<=18} {incr k} {
            if {$aacb($k,$cn)==1} {
                set vaad [expr $vaad + pow(($xscr($cn,$j,$k)-$xd($k,.ii$cn.f1.$j.c1)),2) \
                                     + pow(($yscr($cn,$j,$k)-$yd($k,.ii$cn.f1.$j.c1)),2)]
            }
        }

        if {$vaad > $vaadold} {
            if {$mtype==0} {
                .ii$cn.f1.$j.f3.e4 delete 0 end
                .ii$cn.f1.$j.f3.e4 insert 0 $xaa
            } elseif {$mtype==1} {
                .ii$cn.f1.$j.f3.e5 delete 0 end
                .ii$cn.f1.$j.f3.e5 insert 0 $xaa
            } elseif {$mtype==2} {
                .ii$cn.f1.$j.f3.e6 delete 0 end
                .ii$cn.f1.$j.f3.e6 insert 0 $xaa
            } elseif {$mtype==3} {
                .ii$cn.f1.$j.f3.e7 delete 0 end
                .ii$cn.f1.$j.f3.e7 insert 0 $xaa
            } else {
                .ii$cn.f1.$j.f3.e8 delete 0 end
                .ii$cn.f1.$j.f3.e8 insert 0 $xaa
            }
            IIRot $cn $j
            update
            #wm withdraw .aam
            wm withdraw .aagoing
            return
        } else {
            set vaadold $vaad
            set xaa [expr $xaa + $xdirec * $aastep]
        }
    }
}


proc AutoAdjustAllOn { cn } {
    global aacb aacboff
    for {set k 1} {$k<=18} {incr k} {
        set aacb($k,$cn) 1
    }
    set aacboff($cn) 0
}


proc AutoAdjustAllOff { cn } {
    global aacb aacbon
    for {set k 1} {$k<=18} {incr k} {
        set aacb($k,$cn) 0
    }
    set aacbon($cn) 0
}


proc AutoAdjustAllCheck { cn } {
    global aacb aacbon aacboff
    set allon 1
    for {set k 1} {$k<=18} {incr k} {
        if {$aacb($k,$cn)==0} {
            set allon 0
        }
    }
    if {$allon==1} {
        set aacbon($cn) 1
    } else {
        set aacbon($cn) 0
    }

    set alloff 1
    for {set k 1} {$k<=18} {incr k} {
        if {$aacb($k,$cn)==1} {
            set alloff 0
        }
    }
    if {$alloff==1} {
        set aacboff($cn) 1
    } else {
        set aacboff($cn) 0
    }
}


# Initialization
set swimmer_initialized 0
set initial_imagedir [pwd]

